# Python 开发记录


&lt;!--more--&gt;

## Python 安装
点击 `Downloads`，选择对应匹配的操作系统  

{{&lt; image src=&#34;/images/posts/Python开发记录/11.jpg&#34; caption=&#34;(`图11`)&#34; &gt;}}  

点进去之后，`Python` 的版本分为稳定的版本和前置版本，前置的版本就是还没有发行的版本，我们这里选择稳定的版本即可，根据自己的操作系统进行版本的选择  

{{&lt; image src=&#34;/images/posts/Python开发记录/12.jpg&#34; caption=&#34;(`图12`)&#34; &gt;}}  

然后进行安装即可，这里选择 `Add python.exe to PATH`，即添加 `Python` 的环境变量，然后立即安装  

{{&lt; image src=&#34;/images/posts/Python开发记录/13.jpg&#34; caption=&#34;(`图13`)&#34; &gt;}}  

安装完成后，进行如下测试，也可以进行其他的测试，如果运行正常，则表明 `Python` 的 运行环境安装成功了  

{{&lt; image src=&#34;/images/posts/Python开发记录/14.jpg&#34; caption=&#34;(`图14`)&#34; &gt;}}  

{{&lt; image src=&#34;/images/posts/Python开发记录/15.jpg&#34; caption=&#34;(`图15`)&#34; &gt;}}


## PyCharm 安装
安装社区版  

{{&lt; image src=&#34;/images/posts/Python开发记录/16.jpg&#34; caption=&#34;(`图16`)&#34; &gt;}}  

{{&lt; image src=&#34;/images/posts/Python开发记录/17.jpg&#34; caption=&#34;(`图17`)&#34; &gt;}}  

安装中文插件  

{{&lt; image src=&#34;/images/posts/Python开发记录/18.jpg&#34; caption=&#34;(`图18`)&#34; &gt;}}  

更换 `python` 版本  

{{&lt; image src=&#34;/images/posts/Python开发记录/19.jpg&#34; caption=&#34;(`图19`)&#34; &gt;}}  


### PyCharm 在下载安装第三方库时速度慢或超时问题 / 切换国内镜像地址

#### 方式一：切换国内镜像的地址

{{&lt; image src=&#34;/images/posts/Python开发记录/20.jpg&#34; caption=&#34;(`图20`)&#34; &gt;}}  

{{&lt; image src=&#34;/images/posts/Python开发记录/21.jpg&#34; caption=&#34;(`图21`)&#34; &gt;}}  

添加源地址  
- 阿里云 `http://mirrors.aliyun.com/pypi/simple/`
- 中国科技大学 `https://pypi.mirrors.ustc.edu.cn/simple/`
- 豆瓣 `http://pypi.douban.com/simple/`
- 清华大学 `https://pypi.tuna.tsinghua.edu.cn/simple/`
- 中国科学技术大学 `http://pypi.mirrors.ustc.edu.cn/simple/`


#### 方式二：代理

保存确定，重启运行  

{{&lt; image src=&#34;/images/posts/Python开发记录/22.jpg&#34; caption=&#34;(`图22`)&#34; &gt;}}  

{{&lt; image src=&#34;/images/posts/Python开发记录/23.jpg&#34; caption=&#34;(`图23`)&#34; &gt;}}  


## pip 源设置

通常只执行第一个命令就可以了  

``` shell
pip config set global.index-url https://mirrors.aliyun.com/pypi/simple
pip config set install.trusted-host mirrors.aliyun.com
```

**pip config set global.index-url https://mirrors.aliyun.com/pypi/simple**
- 含义：这条命令将 `pip` 的默认索引 `URL` 设置为阿里云提供的 `PyPI` 镜像服务器地址。这意味着当你运行 `pip install &lt;package&gt;` 命令时，`pip` 会优先从这个镜像服务器而不是官方的 `PyPI（https://pypi.org/simple`）下载包。
- 作用：由于阿里云的镜像服务器位于中国境内，对于中国的用户来说，这通常可以提供更快的下载速度和更稳定的连接。  

**pip config set install.trusted-host mirrors.aliyun.com**
- 含义：这条命令将 `mirrors.aliyun.com` 添加到可信主机列表中。当 `pip` 从非 `HTTPS` 源或自签名证书的 `HTTPS` 源下载文件时，它会检查该源是否在可信主机列表中。如果不在列表中，默认情况下 `pip` 会抛出安全警告或错误。
- 作用：通过将阿里云镜像服务器添加到可信主机列表，你告诉 `pip` 可以信任来自该服务器的包，从而避免了与 `SSL/TLS` 相关的安全警告或错误。  






## 保存前端传过来的文件

```python {data-open=true}
import traceback
from typing import List

from fastapi import UploadFile, File, Form
from config.setting import getDB
from sqlalchemy import select, update
from kbAdmin.Models import models
import os.path
import uuid
import shutil
import ast
import json
from util.ReturnDatas import ReturnDatas
import hashlib

STATICDIR= &#34;./static/&#34;
up_htmlImage = STATICDIR &#43; &#34;htmlimage&#34;

&#34;&#34;&#34;
图片管理-上传图片
&#34;&#34;&#34;
@kb_router.post(&#34;/uploadImage&#34;)
async def uploadImage(file: UploadFile = File(...), documentId: str = Form(...)):
    try:
        # 根据文档id，查出picture的值
        with getDB() as db:
            s = select(models.Document).where(models.Document.id == documentId)
            result = db.scalars(s).first()

        # 获取文件的后缀
        file_extension = file.filename.split(&#34;.&#34;)[-1]

        # 计算文件的哈希值(保存文件后在删除，是为了获取文件的hash值)
        path = up_htmlImage &#43; &#34;/&#34; &#43; result.knowledgeBaseId &#43; &#34;/&#34; &#43; result.id
        os.makedirs(path, exist_ok=True)

        img_id = uuid.uuid4().hex
        temp_name = img_id &#43; &#34;.&#34; &#43; file_extension
        await file.seek(0)  # 确保文件指针在开始位置
        # 写入文件到目标路径
        with open(path &#43; &#34;/&#34; &#43; temp_name, &#34;wb&#34;) as buffer:
            shutil.copyfileobj(file.file, buffer)

        # 获取哈希
        hash_value = calculate_sha256(path &#43; &#34;/&#34; &#43; temp_name)

        # 将其哈希值当作文件名
        name = hash_value &#43; &#34;.&#34; &#43; file_extension
        newFilename = os.path.join(path, name)
        if os.path.exists(newFilename):
            ##删除原文件
            os.remove(newFilename)
            os.rename(path &#43; &#34;/&#34; &#43; temp_name, path &#43; &#34;/&#34; &#43; name)
        else:
            os.rename(path &#43; &#34;/&#34; &#43; temp_name, path &#43; &#34;/&#34; &#43; name)

        # 组合新的picture的值
        pictureUrl = result.picture
        arr: List[str] = []
        if  pictureUrl == &#39;&#39; or pictureUrl is None:
            arr.append(name)
        else:
            arr = ast.literal_eval(pictureUrl)
            # 相同的文件，删除旧的，添加新的
            if name in arr:
                arr.remove(name)
            arr.append(name)

        # 保存图片
        # 目标目录路径
        target_directory = up_htmlImage &#43; &#39;/&#39; &#43; result.knowledgeBaseId &#43; &#39;/&#39; &#43; result.id
        # 确保目标目录存在
        os.makedirs(target_directory, exist_ok=True)

        # 目标文件路径
        target_file_path = os.path.join(target_directory, name)

        # 相同的文件，删除旧的，添加新的
        if os.path.exists(target_file_path):
            ##删除原文件
            os.remove(target_file_path)

        await file.seek(0)  # 确保文件指针在开始位置
        # 写入文件到目标路径
        with open(target_file_path, &#34;wb&#34;) as buffer:
            shutil.copyfileobj(file.file, buffer)

        # 更新picture信息
        with getDB() as db:
            uptesSql = (update(models.Document).where(models.Document.id == documentId).values(picture=json.dumps(arr)))
            print(uptesSql)
            updateResult = db.execute(uptesSql)
            db.commit()

            # 获取受影响的行数
            if updateResult.rowcount &gt; 0:
                return ReturnDatas().SuccessResponse(message=&#34;上传成功 !!!! &#34;)
            else:
                return ReturnDatas.ErrorResponse(message=&#34;上传失败&#34;)

    except Exception as e:
        traceback.print_exc()


&#34;&#34;&#34;根据文件路径求取哈希值&#34;&#34;&#34;
def calculate_sha256(file_path):
    uploaded_hash = hashlib.sha256()
    with open(file_path, &#34;rb&#34;) as file:
        chunk = file.read(8192)
        while chunk:
            uploaded_hash.update(chunk)
            chunk = file.read(8192)

    uploaded_hash_value = uploaded_hash.hexdigest()
    return uploaded_hash_value

&#34;&#34;&#34;根据文件内容求取哈希值&#34;&#34;&#34;
async def calculate_file_hash(file):
    hasher = hashlib.sha256()
    await file.seek(0)  # 确保文件指针在开始位置

    while True:
        chunk = await file.read(8192)
        if not chunk:  # 当 chunk 为空字节串（即文件读取完毕）时，退出循环
            break
        hasher.update(chunk)

    await file.seek(0)  # 重置文件指针到开始位置，以便后续操作
    return hasher.hexdigest()
```


## 读取 Excel 文件

### 安装所需要的库  

``` python {data-open=true}
pip install pandas openpyxl
```

### 样例

{{&lt; image src=&#34;/images/posts/Python开发记录/1.jpg&#34; caption=&#34;(`图1`)&#34; &gt;}}

``` python {data-open=true}
async def uploadQA(file: UploadFile = File(...), kbId: str = Form(...)):
    # 读取上传的文件
    contents = await file.read()
    # 将文件内容加载到 pandas DataFrame
    df = pd.read_excel(BytesIO(contents))
    # 标题
    title_row = df.columns
    question = title_row[0]
    answer = title_row[1]

    # 处理数据
    # 选取DataFrame df 中从第0行开始到最后的所有行
    data_df = df.iloc[0:]
    combined_data = []
    for index, row in data_df.iterrows():
        # 拼接第一列和第二列的数据
        combined_value = f&#34;{question}:{row[0]}。{answer}:{row[1]}&#34;
        combined_data.append(combined_value)
    print(combined_data)
```

运行结果为  

``` Markdown {data-open=true}
[&#39;问题:你今天吃了什么。答案:我还不饿&#39;, &#39;问题:天气晴朗吗。答案:还不错哦&#39;, &#39;问题:你好呀。答案:嗯，你好&#39;]
```

``` python {data-open=true,title=&#34;读取 excel 中的内容，将每行数据处理后，转为文件进行其他操作&#34;}
@kb_router.post(&#34;/uploadQA&#34;)
async def uploadQA(file: UploadFile = File(...), kbId: str = Form(...)):
    # 读取上传的文件
    contents = await file.read()
    # 将文件内容加载到 pandas DataFrame
    df = pd.read_excel(BytesIO(contents))
    # 标题
    title_row = df.columns
    question = title_row[0]
    answer = title_row[1]

    # 处理数据
    data_df = df.iloc[0:]
    combined_data = []
    for index, row in data_df.iterrows():
        # 拼接第一列和第二列的数据
        combined_value = f&#34;{question}:{row[0]}。{answer}:{row[1]}&#34;
        combined_data.append(combined_value)

    if len(combined_data) == 0:
        return ReturnDatas.ErrorResponse(message=&#34;请填写内容 !!&#34;)

    try:
        for item in combined_data:
            file = io.BytesIO(item.encode())
            # 创建 UploadFile 对象
            upFile = UploadFile(filename=uuid.uuid4().hex &#43; &#34;.txt&#34;, file=file)
            # 调用其他操作
            await uploadCommodityInfo(upFile, kbId)
    except  Exception as e:
        traceback.print_exc()
        return ReturnDatas().ErrorResponse(message={&#34;error&#34;: f&#34;An error occurred: {str(e)}&#34;})

    return ReturnDatas().SuccessResponse(message=&#34;上传成功 !!!! &#34;)
```


### 读取-sheet
使用 `pandas` 的 `read_excel()` 方法，可通过文件路径直接读取。注意：在一个 `excel` 文件中有多个 `sheet`，因此，对 `excel` 文件的读取实际上是读取指定文件、并同时指定 `sheet` 下的数据。可以一次读取一个 `sheet`，也可以一次读取多个 `sheet`，同时读取多个 `sheet` 时后续操作可能不够方便，因此建议一次性只读取一个 `sheet`。  

当只读取一个 `sheet` 时，返回的是 `DataFrame` 类型，这是一种表格数据类型，它清晰地展示出了数据的表格型结构。具体写法为：  

(1) 不指定 `sheet` 参数，默认读取第一个 `sheet`  

``` Markdown {.no-header}
df=pd.read_excel(&#34;data_test.xlsx&#34;)
```
(2) 指定 `sheet` 名称读取  

``` Markdown {.no-header}
df=pd.read_excel(&#34;data_test.xlsx&#34;,sheet_name=&#34;test1&#34;)
```
(3)指定sheet索引号读取  

``` Markdown {.no-header}
df=pd.read_excel(&#34;data_test.xlsx&#34;,sheet_name=0) #sheet索引号从0开始
```

{{&lt; admonition type=NOTE title=&#34;同时读取多个 sheet，以字典形式返回。(不推荐)&#34; open=true &gt;}}

(1) 指定多个 `sheet` 名称读取
``` Markdown {.no-header}
df=pd.read_excel(&#34;data_test.xlsx&#34;,sheet_name=[&#34;test1&#34;,&#34;test2&#34;])
```

(2) 指定多个 `sheet` 索引号读取
``` Markdown {.no-header}
df=pd.read_excel(&#34;data_test.xlsx&#34;,sheet_name=[0,1])
```

(3) 混合指定 `sheet` 名称和 `sheet` 索引号读取
``` Markdown {.no-header}
df=pd.read_excel(&#34;data_test.xlsx&#34;,sheet_name=[0,&#34;test2&#34;])
```
{{&lt; /admonition &gt;}}


### DataFrame 对象的结构
对内容的读取分有表头和无表头两种方式，默认情形下是有表头的方式，即将第一行元素自动置为表头标签，其余内容为数据；当在 `read_excel()` 方法中加上 `header=None` 参数时是不加表头的方式，即从第一行起，全部内容为数据。读取到的 `Excel` 数据均构造成并返回 `DataFrame` 表格类型(以下以 `df` 表示)。  

#### 有表头
对有表头的方式，读取时将自动地将第一行元素置为表头向量，同时为除表头外的各行内容加入行索引（从 `0` 开始）、各列内容加入列索引（从 `0` 开始）。如图所示  

{{&lt; image src=&#34;/images/posts/Python开发记录/2.jpg&#34; caption=&#34;(`图2`)&#34; &gt;}}

打印 `样例` 中的 `df`

``` python {data-open=true}
df = pd.read_excel(BytesIO(contents))
print(df)
```

打印结果如下

``` Markdown {data-open=true}
        问题    答案
0  你今天吃了什么  我还不饿
1    天气晴朗吗  还不错哦
2      你好呀  嗯，你好
```

#### 无表头
对无表头的方式，读取时将自动地为各行内容加入行索引（从 `0` 开始）、为各列内容加入列索引（从 `0` 开始），行索引从第一行开始。如图所示  

{{&lt; image src=&#34;/images/posts/Python开发记录/3.jpg&#34; caption=&#34;(`图3`)&#34; &gt;}}  

打印 `样例` 中的 `df`

``` python {data-open=true}
df = pd.read_excel(BytesIO(contents), header=None)
print(df)
```

打印结果如下

``` {data-open=true}
         0     1
0       问题    答案
1  你今天吃了什么  我还不饿
2    天气晴朗吗  还不错哦
3      你好呀  嗯，你好
```


### 用 values 方式获取数据

#### 基本方法
- `df.values`：获取全部数据，返回类型为 `ndarray`（二维）；
- `df.index.values`：获取行索引向量，返回类型为 `ndarray`（一维）；
- `df.columns.values`：获取列索引向量（对有表头的方式，是表头标签向量），返回类型为 `ndarray`（一维）。

根据具体需要，通过 `ndarray` 的使用规则获取指定数据。数据获取的结构示意图如下所示。

##### 有表头

{{&lt; image src=&#34;/images/posts/Python开发记录/4.jpg&#34; caption=&#34;(`图4`)&#34; &gt;}}  

##### 无表头

{{&lt; image src=&#34;/images/posts/Python开发记录/5.jpg&#34; caption=&#34;(`图5`)&#34; &gt;}}


#### 获取指定数据的写法
(1) 获取全部数据：  
`df.values`，获取全部数据，返回类型为 `ndarray`（二维）。  
&amp;emsp;&amp;emsp;  
(2) 获取某个值：  
`df.values[i , j]`，第 `i` 行第 `j` 列的值，返回类型依内容而定。  
&amp;emsp;&amp;emsp;  
(3) 获取某一行：  
`df.values[i]`，第 `i` 行数据，返回类型为 `ndarray`（一维）。  
&amp;emsp;&amp;emsp;  
(4) 获取多行：  
`df.values[[i1 , i2 , i3]]`，第 `i1`、`i2`、`i3` 行数据，返回类型为 `ndarray`（二维）。  
&amp;emsp;&amp;emsp;  
(5) 获取某一列：  
`df.values[: , j]`，第 `j` 列数据，返回类型为 `ndarray`（一维）。  
&amp;emsp;&amp;emsp;  
(6) 获取多列：  
`df.values[:,[j1,j2,j3]]`，第 `j1`、`j2`、`j3` 列数据，返回类型为 `ndarray`（二维）。  
&amp;emsp;&amp;emsp;  
(7) 获取切片：  
`df.values[i1:i2 , j1:j2]`，返回行号 `[i1,i2)`、列号 `[j1,j2)` 左闭右开区间内的数据，返回类型为 `ndarray`（二维）。


#### 示例
带表头，`excel` 内容如下所示  

{{&lt; image src=&#34;/images/posts/Python开发记录/6.jpg&#34; caption=&#34;(`图6`)&#34; &gt;}}

``` python {data-open=true}
import pandas as pd

df = pd.read_excel(&#34;data_test.xlsx&#34;)

print(&#34;\n(1)全部数据：&#34;)
print(df.values)

print(&#34;\n(2)第2行第3列的值：&#34;)
print(df.values[1,2])

print(&#34;\n(3)第3行数据：&#34;)
print(df.values[2])

print(&#34;\n(4)获取第2、3行数据：&#34;)
print(df.values[[1,2]])

print(&#34;\n(5)第2列数据：&#34;)
print(df.values[:,1])

print(&#34;\n(6)第2、3列数据：&#34;)
print(df.values[:,[1,2]])

print(&#34;\n(7)第2至4行、第3至5列数据：&#34;)
print(df.values[1:4,2:5])
```

执行结果  
{{&lt; image src=&#34;/images/posts/Python开发记录/7.jpg&#34; caption=&#34;(`图7`)&#34; &gt;}}  



### 用 loc 和 iloc 方式获取数据

#### 基本写法
`loc` 和 `iloc` 方法是通过索引定位的方式获取数据的，写法为 `loc[A, B]` 和 `iloc[A, B]`。其中 `A` 表示对行的索引，`B` 表示对列的索引，`B` 可缺省。`A`、`B` 可为列表或 `i1:i2`（切片）的形式，表示多行或多列。  

这两个方法的区别是，`loc` 将参数当作标签处理，`iloc` 将参数当作索引号处理。也就是说，在有表头的方式中，当列索引使用 `str` 标签时，只可用 `loc`，当列索引使用索引号时，只可用 `iloc`；在无表头的方式中，索引向量也是标签向量，`loc` 和 `iloc` 均可使用；在切片中，`loc` 是闭区间，`iloc` 是半开区间。  


**获取指定数据的写法**  
(1) 获取全部数据：  
`df.loc[: , :].values`  
或  
`df.iloc[: , :].values`，返回类型为 `ndarray`（二维）。  
&amp;emsp;&amp;emsp;  
(2) 获取某个值：  
无表头  
`df.loc[i, j]`  
或  
`df.iloc[i, j]`，第 `i` 行第 `j` 列的值，返回类型依内容而定。  
&amp;emsp;&amp;emsp;  
有表头  
`df.loc[i, &#34;序号&#34;]`，第 `i` 行 `序号` 列的值。  
或  
`df.iloc[i, j]`，第 `i` 行第 `j` 列的值。  
&amp;emsp;&amp;emsp;  
(3) 获取某一行：  
`df.loc[i].values`  
或  
`df.iloc[i].values`，第 `i` 行数据，返回类型为 `ndarray`（一维）。  
&amp;emsp;&amp;emsp;  
(4) 获取多行：  
`df.loc[[i1, i2, i3]].values`，  
或  
`df.iloc[[i1, i2, i3]].values`，第 `i1`、`i2`、`i3` 行数据，返回类型为 `darray`（二维）。  
&amp;emsp;&amp;emsp;  
(5) 获取某一列：  
无表头  
`df.loc[:, j].values`  
或  
`df.iloc[:, j].values`，第 `j` 列数据，返回类型为 `ndarray`（一维）。  
&amp;emsp;&amp;emsp;  
有表头  
`df.loc[:,&#34;姓名&#34;].values`，`姓名` 列数据，返回类型为 `ndarray`（一维）。  
或  
`df.iloc[:, j].values`，第 `j` 列数据，返回类型为`ndarray`（一维）。  
&amp;emsp;&amp;emsp;    
(6) 获取多列：  
无表头  
`df.loc[:, [j1 , j2]].values`  
或  
`df.iloc[:, [j1 , j2]].values`，第 `j1`、`j2` 列数据，返回类型为 `ndarray`（二维）。  
&amp;emsp;&amp;emsp;  
有表头  
`df.loc[:, [&#34;姓名&#34;,&#34;性别&#34;]].values`，`姓名`、`性别` 列数据，返回类型为 `ndarray`（二维）；  
`df.iloc[:, [j1 , j2]].values`，第 `j1`、`j2` 列数据，返回类型为 `ndarray`（二维）。  
&amp;emsp;&amp;emsp;  
(7) 获取切片：  
无表头  
`df.loc[i1:i2, j1:j2].values`，返回行号 `[i1,i2]`、列号 `[j1,j2]` 闭区间内的数据，返回类型为 `ndarray`（二维）；  
`df.iloc[i1:i2, j1:j2].values`，返回行号 `[i1,i2)`、列号 `[j1,j2)` 左闭右开区间内的数据，返回类型为 `ndarray`（二维）。  
&amp;emsp;&amp;emsp;  
有表头  
`df.loc[i1:i2, &#34;序号&#34;:&#34;姓名&#34;].values`，返回行号 `[i1,i2]`、列号 `[&#34;序号&#34;,&#34;姓名&#34;]` 闭区间的数据，返回类型为 `ndarray`（二维）；  
`df.iloc[i1:i2, j1:j2].values`，返回行号 `[i1,i2)`、列号 `[j1,j2)` 左闭右开区间内的数据，返回类型为 `ndarray`（二维）。


#### 示例
带表头，`excel` 内容如下  

{{&lt; image src=&#34;/images/posts/Python开发记录/8.jpg&#34; caption=&#34;(`图8`)&#34; &gt;}}  


``` python {data-open=true}
import pandas as pd

df = pd.read_excel(&#34;data_test.xlsx&#34;)

print(&#34;\n(1)全部数据：&#34;)
print(df.iloc[:,:].values)

print(&#34;\n(2)第2行第3列的值：&#34;)
print(df.iloc[1,2])

print(&#34;\n(3)第3行数据：&#34;)
print(df.iloc[2].values)

print(&#34;\n(4)第2列数据：&#34;)
print(df.iloc[:,1].values)

print(&#34;\n(5)第6行的姓名：&#34;)
print(df.loc[5,&#34;姓名&#34;])

print(&#34;\n(6)第2至3行、第3至4列数据：&#34;)
print(df.iloc[1:3,2:4].values)
```

执行结果  

{{&lt; image src=&#34;/images/posts/Python开发记录/9.jpg&#34; caption=&#34;(`图9`)&#34; &gt;}}



## 生成验证码

需要安装 `pillow` 模块  

生成验证码需要用到 `arial.ttf` 字体，本地运行时，如果没有设置字体所在的路径，会自动使用操作系统上安装的 `arial.ttf` 字体  

如果把程序放到服务器运行，记得要上传字体  

``` {data-open=true}
pip install pillow
```

``` python {data-open=true,linenos=table,hl_lines=[23],linenostart=1}
import random
from PIL import Image, ImageDraw, ImageFont

&#39;&#39;&#39;
生成验证码
&#39;&#39;&#39;
def generate_code(length):
    # 随机选择字符
    characters = &#34;0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ&#34;
    # 生成指定长度的验证码
    code = &#39;&#39;.join(random.choice(characters) for i in range(length))
    return code

&#39;&#39;&#39;
生成验证码图片
&#39;&#39;&#39;
def generate_image(code, width, height, font_size):
    # 创建一个新的图片对象
    img = Image.new(mode=&#39;RGB&#39;, size=(width, height), color=(255, 255, 255))
    # 创建一个画笔对象
    draw = ImageDraw.Draw(img)
    # 设置字体
    font = ImageFont.truetype(&#39;arial.ttf&#39;, font_size)
    # 获取字符的宽度和高度
    # text_width, text_height = draw.textsize(code, font)
    # 获取字符的宽度和高度
    bbox = draw.textbbox((0, 0, width, height), code, font=font)
    text_width = bbox[2] - bbox[0]
    text_height = bbox[3] - bbox[1]

    # 将字符绘制在图片中央
    x = (width - text_width) // 2
    y = (height - text_height) // 2
    draw.text((x, y), code, font=font, fill=(0, 0, 0))
    # 添加干扰线
    for i in range(5):
        x1 = random.randint(0, width)
        y1 = random.randint(0, height)
        x2 = random.randint(0, width)
        y2 = random.randint(0, height)
        draw.line((x1, y1, x2, y2), fill=(0, 0, 0), width=2)
    # 添加干扰点
    for i in range(50):
        x = random.randint(0, width)
        y = random.randint(0, height)
        draw.point((x, y), fill=(0, 0, 0))
    # 返回验证码图片对象
    return img

&#39;&#39;&#39;
保存验证码图片
&#39;&#39;&#39;
def save_image(img, path):
    img.save(path)

```

测试  

``` python {data-open=true}
if __name__ == &#39;__main__&#39;:
    code = generate_code(4)
    img = generate_image(code, 150, 50, 30)
    save_image(img, &#39;captcha.png&#39;)
    img.show()

```

### 使用 session 存储验证码

这里的 `request.session` 是 `Starlette` 中的 `session`

``` python {data-open=true}
&#39;&#39;&#39;
生成验证码
&#39;&#39;&#39;
@user_router.post(&#34;/verificationCode&#34;)
def verificationCode(request: Request):
    code = VerificationCodeUtil.generate_code(4)
    img = VerificationCodeUtil.generate_image(code, 110, 40, 30)

    # 将验证码存储到会话中
    request.session[&#39;verification_code&#39;] = code

    print(&#34;验证码&#34; &#43; code)

    buffer=BytesIO()
    img.save(buffer,&#34;PNG&#34;)
    # 从内存中取出bytes类型的图片
    buf_bytes = buffer.getvalue()

    # 将图片转换为 base64 编码
    base64_image = base64.b64encode(buf_bytes).decode(&#39;utf-8&#39;)

    return ReturnDatas.SuccessResponse(message=&#34;获取成功&#34;, data=base64_image)
```

将生成的验证码图片返回给前端后，在前端登录页面展示  

{{&lt; image src=&#34;/images/posts/Python开发记录/10.jpg&#34; caption=&#34;(`图10`)&#34; &gt;}}

``` html {data-open=true}
&lt;template&gt;
  &lt;el-form-item class=&#34;login-form-pwd&#34; label=&#34;验证码&#34; prop=&#34;code&#34;&gt;
    &lt;el-input
      type=&#34;code&#34;
      size=&#34;large&#34;
      placeholder=&#34;请输入验证码&#34;
      v-model=&#34;form.code&#34;
      style=&#34;flex: 1;&#34;
    &gt;&lt;/el-input&gt;
    &lt;img :src=&#34;imageUrl&#34; alt=&#34;验证码&#34; @click=&#34;getCode()&#34; title=&#34;点击刷线验证码&#34;/&gt;
  &lt;/el-form-item&gt;
&lt;/template&gt;
&lt;script&gt;
export default {
  setup() {
    const imageUrl = ref(&#39;&#39;)

    //获取验证码
    const getCode = () =&gt; { 
      landRelevant.verificationCode().then((res) =&gt; { 
        // 更新 Vue 组件中的图片 URL
        imageUrl.value = &#39;data:image/png;base64,&#39;&#43;res.data;
      })
    }
  }
}
&lt;/script&gt;
```

在登录时从 `session` 中取出验证码，对比上传的验证码

``` python {data-open=true}
code = request.session.get(&#39;verification_code&#39;)
if code != uservo.code:
    return ReturnDatas.ErrorResponse(message=&#34;验证码错误,请重试!失败&#34;)
```

在 `main.py` 中添加中间件  

``` python {data-open=true}
from starlette.middleware.sessions import SessionMiddleware
import os

app.add_middleware(SessionMiddleware, secret_key=os.urandom(24))
```

`app.add_middleware(SessionMiddleware, secret_key=os.urandom(24))`：对所有的 `session` 数据进行加密和签名，这意味着所有通过这个中间件管理的 `session` 都会受到该密钥的保护。  

每次重启应用时，`os.urandom(24)` 都会生成一个新的随机密钥。这意味着所有现有的 `session` 将失效，因为它们是基于旧的密钥加密的。  

如果应用场景是生成图片验证码，并且希望每次重启应用时都使之前的验证码失效，那么使用 `os.urandom(24)` 生成一个随机的 `secret_key` 是合适的。这种方式确保了每次应用重启后，旧的 `session`（包括验证码）都会失效，从而增强了安全性。  

整体流程：后端生成验证码放入到 `session` 中，经过 `secret_key` 的加密后，存储到用户的浏览器的 `cookie` 中，然后将验证码图片返回给前端，在前端展示，用户输入验证码后，前端将用户输入的验证码和浏览器的 `cookie` 发送到后端，后端从 `session` 中取出验证码比对。  




### 不同库中的 session

`Starlette` 和 `FastAPI-Sessions` 都提供了会话管理的功能，但它们的工作方式有所不同。下面我会解释这两种方式的主要区别以及它们如何存储数据以供多次请求间共享。  

#### Starlette 的会话管理

`Starlette` 是 `FastAPI` 使用的基础 `ASGI（Asynchronous Server Gateway Interface）` 框架，它自带了一套简单的会话管理机制。`Starlette` 的会话管理主要基于 `cookies` 和后端存储（通常是数据库或内存）。  

`Starlette` 的 `session` 使用方式  
- 使用 `Starlette` 提供的 `SessionMiddleware` 来添加会话支持。
- 通过 `request.session` 访问会话数据。
- 通常会话数据会被加密并存储在客户端的 `cookie` 中。
- 为了性能考虑，会话数据也可以被存储在服务器端，例如 `Redis`、数据库等。

`Starlette` 的 `session` 特点  
- 简单易用：适合简单的应用。
- 默认基于 `cookie`：数据量不宜过大，因为它们会被编码成 `cookie` 的形式发送给客户端。
- 可扩展：可以通过配置不同的会话后端来适应不同的需求。


#### FastAPI-Sessions 库
`FastAPI-Sessions` 是一个额外的库，专门用于在 `FastAPI` 应用中提供更高级的会话管理功能。它的设计更加灵活和可定制，可以更好地适应复杂的会话管理需求。  

`FastAPI-Sessions` 的使用方式
- 需要安装 `fastapi_sessions` 库。
- 定义自己的会话类，如 `Backend`, `Serializer`, `SessionData` 等。
- 通过 `Session` 对象访问会话数据。
- 通常会话数据会被存储在服务器端，如 `Redis`、数据库等。

`FastAPI-Sessions` 的特点
- 高度可定制：可以定制会话的存储、序列化、过期时间等。
- 不依赖 `cookie`：虽然可以使用 `cookie` 来传递会话标识符，但数据本身不需要存储在客户端。
- 适用于大型应用：更适合需要复杂会话管理的应用场景。

&amp;emsp;&amp;emsp;

**主要区别** 

实现方式
- `Starlette` 的会话管理更为直接和简单，适合快速开发。
- `FastAPI-Sessions` 更加灵活和可定制，适用于需要更多控制的应用。

数据存储位置
- `Starlette` 默认将数据存储在客户端的 `cookie` 中，而 `FastAPI-Sessions` 则将数据存储在服务器端。
- `Starlette` 支持将数据存储在服务器端，但通常需要手动配置。

数据安全性
- 在 `Starlette` 中，会话数据被加密后存储在客户端，因此存在一定的安全风险。
- `FastAPI-Sessions` 通常将数据存储在服务器端，因此更安全一些。



## 测试用例
测试用例编写规范：

- 测试文件名必须以 `&#34;test_&#34;` 开头或者以 `&#34;_test&#34;` 结尾
- 测试类命名以 `Test` 开头
- 测试方法必须以 `&#34;test_&#34;` 开头
- 测试用例包 `pakege` 必须要有 `__init__.py` 文件
- 使用 `assert` 断言`

``` python {data-open=true,linenos=table,hl_lines=[1,3,5,&#34;13-15&#34;],linenostart=1}
import unittest

class TestSample(unittest.TestCase):

	def test_lowercase_and_strip(self):
    # normalizeString 是自定义的方法
		self.assertEqual(normalizeString(&#34; Hello World &#34;), &#34;hello world&#34;)
		external_method()

def external_method():
    print(&#34;测试&#34;)

if __name__ == &#39;__main__&#39;:
	# 跑所有以 test_xx 开头的测试用例
    unittest.main()
```


## 响应文件给前端
场景：前端点击 `下载模板` 文字链接，后端将文件响应给前端，在浏览器中下载  

``` python {data-open=true}
from starlette.responses import FileResponse

@kb_router.get(&#34;/downloadTemplate&#34;)
async def downloadQATemplate():
    file_name = &#34;模板.xlsx&#34;
    file_path = STATICDIR &#43; &#39;template/&#39; &#43; file_name
    return FileResponse(file_path, filename=file_name, media_type=&#39;application/vnd.openxmlformats-officedocument.spreadsheetml.sheet&#39;)
```


## 字典转换

### 样例一
``` python {data-open=true}
@userKB_router.post(&#34;/userKBList&#34;)
async def userKBList(page: Page):
    try:
        # 查询普通用户信息
        with getDB() as db:
            # 查询总记录数
            pageRes = db.execute(text(f&#34; SELECT COUNT(*) as count FROM t_user where \&#34;userType\&#34; = 0 and (active != 0 or active is null)&#34;)).mappings().fetchone()
            # 设置分页大小
            page = page.setPageCount(pageRes[&#34;count&#34;])      
            dbSql = db.query(User)
            dbSql = dbSql.filter(User.userType == 0)
            dbSql = dbSql.filter(or_(User.active != 0,User.active.is_(None)))
            dbSql = dbSql.order_by(desc(User.updateTime))       
            # 查询列表
            result = dbSql.offset((page.pageNo - 1) * page.pageSize).limit(page.pageSize).all()     
            # 查询用户的知识库信息
            results = []
            with getDB() as db:
                for u in result:
                    user_id = u.id
                    s = select(KnowledgeBase.id, KnowledgeBase.name, KnowledgeBase.created_at,
                           KnowledgeBase.type).where(KnowledgeBase.userId == user_id).order_by(desc(KnowledgeBase.update_at))
                    kbList = db.execute(s).all()

                    # 组合数据返回
                    user_dict = u.__dict__.copy()  # 将 User 实体转换为字典
                    # if kbList:
                    user_dict[&#34;knowledgeBase&#34;] = [kb._asdict() for kb in kbList]  # 将知识库列表添加到用户字典中
                    results.append(user_dict)

    except Exception as e:
        traceback.print_exc()
        return ReturnDatas().ErrorResponse(message=&#34;查询失败 ! &#34;)

    return ReturnDatas().SuccessResponse(message=&#34;查询成功&#34;, data=jsonable_encoder(results), page=jsonable_encoder(page))
```

{{&lt; admonition type=NOTE title=&#34;帮助理解&#34; open=true &gt;}}
调用 `kb._asdict()` 时，它会返回一个字典：  

``` python {data-open=true}
{
    &#39;id&#39;: 1,
    &#39;name&#39;: &#39;KB1&#39;,
    &#39;created_at&#39;: datetime.datetime(2023, 1, 1, 0, 0),
    &#39;type&#39;: &#39;Type1&#39;
}
```  

**kb._asdict() for kb in kbList**  
而 `kb._asdict() for kb in kbList` 是一个列表推导式（`list comprehension`），它会对 `kbList` 中的每一个元素 `kb` 执行 `_asdict()` 方法，从而得到一个由字典组成的列表：  

``` python {data-open=true}
[
    {&#39;id&#39;: 1, &#39;name&#39;: &#39;KB1&#39;, &#39;created_at&#39;: datetime.datetime(2023, 1, 1, 0, 0), &#39;type&#39;: &#39;Type1&#39;},
    {&#39;id&#39;: 2, &#39;name&#39;: &#39;KB2&#39;, &#39;created_at&#39;: datetime.datetime(2023, 1, 2, 0, 0), &#39;type&#39;: &#39;Type2&#39;},
    ...
]
```
{{&lt; /admonition &gt;}}


### 样例二
``` python {data-open=true}
@permission_router.post(&#34;/bindPeopleList&#34;)
async def bindPeopleList(page: Page.Page, request: Request):
    try:
        jwt = request.headers.get(&#34;jwttoken&#34;)
        currentUserId = SessionUser.getUserId(jwt)

        account = page.data[&#34;account&#34;]
        with getDB() as db:
            if account != &#39;&#39;:
                # 查询总记录数
                pageRes = db.execute(text(f&#34;&#34;&#34; SELECT COUNT(*) as count FROM user_permission where &#34;userId&#34; = :userId and &#34;bindUserId&#34; like :bindUserId and &#34;status&#34; = :status&#34;&#34;&#34;),{&#34;userId&#34;:currentUserId, &#34;bindUserId&#34;:account, &#34;status&#34;: &#39;1&#39;}).mappings().fetchone()
            else:
                pageRes = db.execute(text(f&#34;&#34;&#34; SELECT COUNT(*) as count FROM user_permission where &#34;userId&#34; = :userId and &#34;status&#34; = :status&#34;&#34;&#34;),{&#34;userId&#34;:currentUserId, &#34;status&#34;: &#39;1&#39;}).mappings().fetchone()

            # 设置分页大小
            page = page.setPageCount(pageRes[&#34;count&#34;])

            # 构建查询
            dbSql = db.query(UserPermission, User.account). \
                join(User, UserPermission.bindUserId == User.id). \
                filter(UserPermission.userId == currentUserId). \
                filter(UserPermission.status == &#39;1&#39;). \
                order_by(desc(UserPermission.create_at))

            if account != &#39;&#39;:
                dbSql = dbSql.filter(User.account.like(f&#39;%{account}%&#39;))

            # 查询列表
            result = dbSql.offset((page.pageNo - 1) * page.pageSize).limit(page.pageSize).all()

            for idx, item in enumerate(result):
                user_permission, user_account = item
                print(f&#34;第 {idx &#43; 1} 条记录:&#34;)
                print(f&#34;UserPermission: {user_permission.__dict__}&#34;)
                print(f&#34;UserAccount: {user_account}\n&#34;)

            # 将查询结果转换为字典
            result_dicts = [
                {
                    &#34;id&#34;: user_permission.id,
                    &#34;userId&#34;: user_permission.userId,
                    &#34;bindUserId&#34;: user_permission.bindUserId,
                    &#34;create_at&#34;: user_permission.create_at,
                    &#34;account&#34;: account
                }
                for user_permission, account in result
            ]


        return ReturnDatas().SuccessResponse(message = &#34;查询成功&#34;, data = jsonable_encoder(result_dicts), page = jsonable_encoder(page))
    except Exception as e:
        traceback.print_exc()
        return ReturnDatas().ErrorResponse(message = &#34;查询失败&#34;)
```

在 `db.query(UserPermission, User.account)` 这里查询了 `2` 张表的数据，所以结果也包含两部分，结果需要转换一下，`for user_permission, account in result` 取出对应的结果赋值  






## 获取列表中的最后一个元素

使用切片来获取列表中的最后一个元素  

``` python {data-open=true}
from sqlalchemy import select, desc
from your_module import WeExternal, getDB  # 替换为你的实际导入路径

with getDB() as db:
    s = select(WeExternal).where(WeExternal.open_kfid == wev.open_kfid).order_by(desc(WeExternal.update_at)).order_by(desc(WeExternal.created_at))
    WeExternalList = db.scalars(s).all()
    
    # 获取最后一条数据
    last_we_external = WeExternalList[-1] if WeExternalList else None
```

## 聊天记录排序
仅限2个人，一问一答  

``` python {data-open=true}
with getDB() as db:
    s = select(ChatRecod).where(ChatRecod.chat_room_id == roomId).order_by(asc(ChatRecod.update_at),asc(ChatRecod.role != &#39;user&#39;))
    chatRecordList = db.scalars(s).all()
```

两个角色分别为 system、user  

先按照 `update_at` 更新时间升序排列，当更新事件相同时，按照角色排序，`asc(ChatRecod.role != &#39;user&#39;)`：按照 `role` 字段是否不等于 `&#39;user&#39;` 升序排列。这里需要注意的是，`ChatRecod.role != &#39;user&#39;` 会生成一个布尔表达式，结果为 `True` 或 `False`。在 `SQL` 中，`False` 通常被视为 `0`，而 `True` 通常被视为 `1`。因此，`role` 不等于 `&#39;user&#39;` 的记录会排在 `role` 等于 `&#39;user&#39;` 的记录之后。

### 进阶
之前：查询全部的聊天记录，前端在展示的时候，会自动下滑到最新的聊天记录  
现在：前端分页聊天记录，前端进入到聊天记录页面，需要展示最新的聊天记录，往上滑，滑倒顶部，在查询第二页的聊天记录  
所以现在查询是倒叙查询，根据时间倒叙排列，查询第一页，从而查询最新的聊天记录，但是这样 `&#39;user&#39;` 和 `&#39;assistant&#39;` 角色的记录反了，在查询完后，需要再反转为正序   

``` python {data-open=true}
async def getChatRecord(page: Page):
    try:
        # 组合roomId
        roomId = page.data[&#34;agentsId&#34;] &#43; page.data[&#34;open_kfid&#34;] &#43; page.data[&#34;external_userid&#34;]
        with (getDB() as db):
            pageRes = db.execute(
                text(f&#34; SELECT COUNT(*) as count FROM chat_recod where chat_room_id = :chat_room_id&#34;),
                {&#34;chat_room_id&#34;: roomId}).mappings().fetchone()
            # 设置分页大小
            page = page.setPageCount(pageRes[&#34;count&#34;])

            s = select(ChatRecod).where(ChatRecod.chat_room_id == roomId).order_by(desc(ChatRecod.update_at),asc(ChatRecod.role != &#39;user&#39;)).offset((page.pageNo - 1) * page.pageSize).limit(page.pageSize)
            chatRecordList = db.scalars(s).all()
            chatRecordList.sort(key=lambda x: (x.update_at, x.role != &#39;user&#39;))

        return ReturnDatas().SuccessResponse(message=&#34;查询成功&#34;, data=jsonable_encoder(chatRecordList), page=jsonable_encoder(page))
    except  Exception as e:
        traceback.print_exc()
    return ReturnDatas.ErrorResponse(message=&#34;查询失败!!&#34;)
```

这行代码 `chatRecordList.sort(key=lambda x: (x.update_at, x.role != &#39;user&#39;))` 的作用是对 `chatRecordList` 列表进行排序。让我们逐步解释这行代码的含义：  

1. `key=lambda x: (x.update_at, x.role != &#39;user&#39;)`
- `lambda x: (x.update_at, x.role != &#39;user&#39;)`：这是一个 `lambda` 函数，用于定义排序的关键字。`x` 是列表中的每个元素（即 `ChatRecod` 对象）。
- `x.update_at`：这是 `ChatRecod` 对象的 `update_at` 属性，表示记录的更新时间。
- `x.role != &#39;user&#39;`：这是一个布尔表达式，表示 `role` 是否不等于 `&#39;user&#39;`。布尔值在 Python 中可以被视为整数，`True` 对应 `1`，`False` 对应 `0`。

2. 排序的关键字
- `(x.update_at, x.role != &#39;user&#39;)`：这是一个元组，包含两个元素：
- 第一个元素是 `x.update_at`，表示按更新时间排序。
- 第二个元素是 `x.role != &#39;user&#39;`，表示按 `role` 是否不等于 `&#39;user&#39;` 排序。

3. 排序规则
- 按 `update_at` 升序排序：首先按 `update_at` 属性进行排序。如果 `update_at` 相同，则继续按第二个关键字排序。
- 按 `role != &#39;user&#39;` 升序排序：如果 `update_at` 相同，那么按 `role` 是否不等于 `&#39;user&#39;` 进行排序。`True` 对应 `1`，`False` 对应 `0`，因此 `role` 不等于 `&#39;user&#39;` 的记录会排在前面。

4. 整体效果
- 主要排序关键字：`update_at`，按更新时间升序排序。
- 次要排序关键字：`role != &#39;user&#39;`，按 `role` 是否不等于 `&#39;user&#39;` 升序排序。




## 组合数据生成文件

``` python {data-open=true}
from fastapi import UploadFile

async def test():
  title = &#34;标题&#34;
  content = &#34;这是一段文字&#34;
  file = io.BytesIO(content.encode())
  # 创建 UploadFile 对象
  upFile = UploadFile(filename=title &#43; &#34;.txt&#34;, file=file)
```


## 命令
`pip freeze &gt; requirements.txt` 命令会列出当前环境中所有已安装的包及其版本号，并且可以直接输出到 `requirements.tx`。  
安装 `requirements.txt` 中所有的依赖：`pip install -r requirements.txt`  


## SQL 

### 在查询总记录数时，like 不生效

like 后的字段用 `f&#34;%{}%&#34;` 的形式  

``` python {data-open=true}
pageRes = db.execute(text(f&#34;&#34;&#34; SELECT COUNT(*) as count FROM user_permission up join t_user u on up.&#34;bindUserId&#34; = u.&#34;id&#34; where up.&#34;userId&#34; = :userId and u.&#34;account&#34; like :account and up.&#34;status&#34; = :status&#34;&#34;&#34;),{&#34;userId&#34;:currentUserId, &#34;account&#34;:f&#34;%{account}%&#34;, &#34;status&#34;: &#39;1&#39;}).mappings().fetchone()
```

## 链式编程换行

在后面跟上 `\`  

``` python {data-open=true}
dbSql = db.query(UserPermission, User.account). \
    join(User, UserPermission.bindUserId == User.id). \
    filter(UserPermission.userId == currentUserId). \
    filter(UserPermission.status == &#39;1&#39;). \
    order_by(desc(UserPermission.create_at))
```

---
{.awesome-hr}




## 上传文件时不处理，后续处理

``` python {data-open=true,linenos=table,hl_lines=[4,64],linenostart=1}
up_filePath = &#34;./static/&#34; &#43; &#34;knowledgeBase&#34;
up_graphPath = &#34;./static/&#34; &#43; &#34;knowledgeGraph&#34;

async def uploadfile(background_tasks: BackgroundTasks,file: UploadFile = File(...), kbId: str = Form(...),upType:str=Form(default=&#34;kowbase_up&#34;)):
    # 检查是否有文件被上传
    try:
        if kbId is None :
            return ReturnDatas().ErrorResponse(message=&#34;知识库不存在!&#34;)
        with getDB() as db:
            s=select(models.KnowledgeBase).where(models.KnowledgeBase.id==kbId)
            kn=db.scalars(s).first()
        name=kn.id
        knowPath=None
        path=None
        tempPath=None
        if upType == &#34;kowbase_up&#34;:
            knowPath=up_filePath
            path = knowPath &#43; &#34;/&#34; &#43; name

            # 创建临时目录
            tempPath=os.path.join(path,&#34;temp&#34;)

        elif upType == &#34;knowGrapth_up&#34;:
            knowPath=up_graphPath &#43; &#34;/&#34; &#43; name
            path=os.path.join(knowPath,&#34;input&#34;)
            # 创建临时目录
            tempPath=os.path.join(path, &#34;temp&#34;)

        if not os.path.exists(knowPath):
            os.makedirs(knowPath)

        if not os.path.exists(path):
            os.makedirs(path)

        if not os.path.exists(tempPath):
            os.makedirs(tempPath)

        #创建临时目录 并存入文件
        temp = NamedTemporaryFile(dir=tempPath)
        content = await file.read()
        temp.write(content)

        #更新数据库数据
        # 新插入数据
        docId = uuid.uuid4().hex
        print(&#34;temp&#34;,temp)
        with getDB() as db:

            doc_data = {
                &#34;id&#34;: docId,
                &#34;knowledgeBaseId&#34;: kbId,
                &#34;path&#34;: os.path.join(path, temp.name),
                &#34;status&#34;: 0,
                &#34;fileName&#34;: file.filename,
                &#34;fileSize&#34;: file.size,
                &#34;createTime&#34;: datetime.now(),
                &#34;updateTime&#34;: datetime.now(),
                &#34;type&#34;: 1
            }
            k = models.Document(**doc_data)
            db.add(k)
            db.commit()

        background_tasks.add_task(upFile, file, path, kbId, upType, temp, docId)

        # 返回成功消息或其他响应
        result={&#34;id&#34;:docId,&#34;object&#34;:&#34;file&#34;,&#34;bytes&#34;:temp.tell(),&#34;created_at&#34;:int(round(time.time() * 1000)),&#34;filename&#34;:file.filename,&#34;purpose&#34;:&#34;fine-tune&#34;}
        return ReturnDatas.SuccessResponse(message=&#34;File uploaded successfully!&#34;,data=jsonable_encoder(result))

    except Exception as e:
        ##logging.error(e)
        traceback.print_exc()

        # 处理异常情况
        return ReturnDatas.ErrorResponse(message={&#34;error&#34;: f&#34;An error occurred: {str(e)}&#34;})
```

`background_tasks.add_task(upFile, file, path, kbId, upType, temp, docId)` 这一行用于将一个后台任务添加到 `FastAPI` 的 `BackgroundTasks` 对象中。这意味着当 `API` 请求处理完毕并返回响应给客户端后，`FastAPI` 会在后台异步执行你指定的任务（在这个例子中是 `upFile` 函数）  

详细解释  
**BackgroundTasks：**
- `BackgroundTasks` 是 `FastAPI` 提供的一个类，允许你在请求完成后继续执行某些操作而不阻塞主请求的响应。  
- 它非常适合用于那些不需要立即完成但又需要执行的任务，例如发送电子邮件、处理文件上传、日志记录等。  

**add_task 方法：**  
- `add_task` 方法用于向 `BackgroundTasks` 添加一个新的后台任务。  
- 它接受的第一个参数是一个可调用对象（通常是函数），后面跟着该函数所需的参数。  

**upFile 函数：**  
- `upFile` 是你定义的一个函数，它将在后台异步执行。  
- 你需要确保这个函数是可以异步执行的，或者至少不会阻塞事件循环。  

**传递参数：**  
- `file, path, kbId, upType, temp` 和 `docId` 是传递给 `upFile` 函数的参数。  
- 这些参数应该与 `upFile` 函数的签名相匹配。  


``` python {data-open=true}
def upFile(file, path, kbId, upType, temp:TemporaryFile, docId):
    try:
        # 检查是否有文件被上传
        if file.filename == &#39;&#39;:
            return ReturnDatas.ErrorResponse(message=&#34;No file provided!&#34;)
        # 计算上传文件的哈希值
        hash_value = hash_file_tempFile(temp)
        # 将其哈希值当作文件名
        file_extension = file.filename.split(&#34;.&#34;)[-1]
        name = hash_value &#43; &#34;.&#34; &#43; file_extension
        # 判断上传的文件是否存在，其文件名就是其内容的哈希值，比较的是哈希值的文件名称,如果存在，表示其哈希值一样
        newPath = os.path.join(path, name)

        if os.path.exists(newPath):
            ##删除原文件
            os.remove(newPath)
        temp.seek(0)    # 确保文件指针在开始位置
        filePath = os.path.join(path, name)

        with open(filePath, &#34;wb&#34;) as buffer:
            shutil.copyfileobj(temp.file, buffer)
        filename = path &#43; &#34;/&#34; &#43; name

        # 仅提取文本内容
        full_text = &#34;&#34;

        # ......
        # 更新上传文件的状态
        return None

    except Exception as e:
        traceback.print_exc()
        # 更新上传文件的状态

    finally:
        # 删除临时文件
        temp.close()


def hash_file_tempFile(file:TemporaryFile):
    hasher = hashlib.sha256()
    # 使用 file.file 来访问文件流
    file_content = file.file
    file_content.seek(0)  # 确保文件指针在开始位置
    while True:
        chunk = file_content.read(8192)
        if not chunk:  # 当 chunk 为空字节串（即文件读取完毕）时，退出循环
            break
        hasher.update(chunk)

    file_content.seek(0)  # 重置文件指针到开始位置，以便后续操作
    return hasher.hexdigest()
```



## 处理 MarkItDown 读取文件中的图片

``` python {title=&#34;测试用例&#34;}
from markitdown import MarkItDown
from openai import OpenAI
# 初始化转换器
client = OpenAI(api_key=&#34;&#34;, base_url=&#34;&#34;)

markitdown = MarkItDown(llm_client=client, llm_model=&#34;&#34;)
mdImage = MarkItDown(llm_client=client, llm_model=&#34;&#34;)

# 转换不同类型的文件
result = markitdown.convert(&#34;xxx.pdf&#34;,llm_prompt=&#34;提取图面内容,总结描述使用中文&#34;)
print(result.text_content)
```

因为 pdfminer 仅处理 pdf 中的文本，所以安装新的依赖。  

``` shell
# 更换镜像
pip config set global.index-url https://mirrors.aliyun.com/pypi/simple/
# 安装
pip install pdfminer.six pymupdf
```

``` python {title=&#34;_markitdown.py&#34;}
# type: ignore
import base64
import binascii
import copy
import html
import json
import mimetypes
import os
import re
import shutil
import subprocess
import sys
import tempfile
import traceback
import zipfile
import uuid
# ---------------------------------
import fitz  # PyMuPDF: 用于处理PDF中的图像和其他复杂内容
from pdfminer.high_level import extract_text  # pdfminer.six: 用于从PDF中提取文本
from typing import Union, Dict, Any, List, Tuple  # 提供类型提示，帮助提高代码可读性和维护性
# ---------------------------------
from typing import Any, Dict, List, Optional, Union
from urllib.parse import parse_qs, quote, unquote, urlparse, urlunparse
from warnings import warn, resetwarnings, catch_warnings

import mammoth
import markdownify
import pandas as pd
import pdfminer
import pdfminer.high_level
import pptx

# File-format detection
import puremagic
import requests
from bs4 import BeautifulSoup
from charset_normalizer import from_path

# Optional Transcription support
try:
    # Using warnings&#39; catch_warnings to catch
    # pydub&#39;s warning of ffmpeg or avconv missing
    with catch_warnings(record=True) as w:
        import pydub

        if w:
            raise ModuleNotFoundError
    import speech_recognition as sr

    IS_AUDIO_TRANSCRIPTION_CAPABLE = True
except ModuleNotFoundError:
    pass
finally:
    resetwarnings()

# Optional YouTube transcription support
try:
    from youtube_transcript_api import YouTubeTranscriptApi

    IS_YOUTUBE_TRANSCRIPT_CAPABLE = True
except ModuleNotFoundError:
    pass


class _CustomMarkdownify(markdownify.MarkdownConverter):
    &#34;&#34;&#34;
    A custom version of markdownify&#39;s MarkdownConverter. Changes include:

    - Altering the default heading style to use &#39;#&#39;, &#39;##&#39;, etc.
    - Removing javascript hyperlinks.
    - Truncating images with large data:uri sources.
    - Ensuring URIs are properly escaped, and do not conflict with Markdown syntax
    &#34;&#34;&#34;

    def __init__(self, **options: Any):
        options[&#34;heading_style&#34;] = options.get(&#34;heading_style&#34;, markdownify.ATX)
        # Explicitly cast options to the expected type if necessary
        super().__init__(**options)

    def convert_hn(self, n: int, el: Any, text: str, convert_as_inline: bool) -&gt; str:
        &#34;&#34;&#34;Same as usual, but be sure to start with a new line&#34;&#34;&#34;
        if not convert_as_inline:
            if not re.search(r&#34;^\n&#34;, text):
                return &#34;\n&#34; &#43; super().convert_hn(n, el, text, convert_as_inline)  # type: ignore

        return super().convert_hn(n, el, text, convert_as_inline)  # type: ignore

    def convert_a(self, el: Any, text: str, convert_as_inline: bool):
        &#34;&#34;&#34;Same as usual converter, but removes Javascript links and escapes URIs.&#34;&#34;&#34;
        prefix, suffix, text = markdownify.chomp(text)  # type: ignore
        if not text:
            return &#34;&#34;
        href = el.get(&#34;href&#34;)
        title = el.get(&#34;title&#34;)

        # Escape URIs and skip non-http or file schemes
        if href:
            try:
                parsed_url = urlparse(href)  # type: ignore
                if parsed_url.scheme and parsed_url.scheme.lower() not in [&#34;http&#34;, &#34;https&#34;, &#34;file&#34;]:  # type: ignore
                    return &#34;%s%s%s&#34; % (prefix, text, suffix)
                href = urlunparse(parsed_url._replace(path=quote(unquote(parsed_url.path))))  # type: ignore
            except ValueError:  # It&#39;s not clear if this ever gets thrown
                return &#34;%s%s%s&#34; % (prefix, text, suffix)

        # For the replacement see #29: text nodes underscores are escaped
        if (
            self.options[&#34;autolinks&#34;]
            and text.replace(r&#34;\_&#34;, &#34;_&#34;) == href
            and not title
            and not self.options[&#34;default_title&#34;]
        ):
            # Shortcut syntax
            return &#34;&lt;%s&gt;&#34; % href
        if self.options[&#34;default_title&#34;] and not title:
            title = href
        title_part = &#39; &#34;%s&#34;&#39; % title.replace(&#39;&#34;&#39;, r&#34;\&#34;&#34;) if title else &#34;&#34;
        return (
            &#34;%s[%s](%s%s)%s&#34; % (prefix, text, href, title_part, suffix)
            if href
            else text
        )

    def convert_img(self, el: Any, text: str, convert_as_inline: bool) -&gt; str:
        &#34;&#34;&#34;Same as usual converter, but removes data URIs&#34;&#34;&#34;

        alt = el.attrs.get(&#34;alt&#34;, None) or &#34;&#34;
        src = el.attrs.get(&#34;src&#34;, None) or &#34;&#34;
        title = el.attrs.get(&#34;title&#34;, None) or &#34;&#34;
        title_part = &#39; &#34;%s&#34;&#39; % title.replace(&#39;&#34;&#39;, r&#34;\&#34;&#34;) if title else &#34;&#34;
        if (
            convert_as_inline
            and el.parent.name not in self.options[&#34;keep_inline_images_in&#34;]
        ):
            return alt

        # Remove dataURIs
        if src.startswith(&#34;data:&#34;):
            src = src.split(&#34;,&#34;)[0] &#43; &#34;...&#34;

        return &#34;![%s](%s%s)&#34; % (alt, src, title_part)

    def convert_soup(self, soup: Any) -&gt; str:
        return super().convert_soup(soup)  # type: ignore


class DocumentConverterResult:
    &#34;&#34;&#34;The result of converting a document to text.&#34;&#34;&#34;

    def __init__(self, title: Union[str, None] = None, text_content: str = &#34;&#34;):
        self.title: Union[str, None] = title
        self.text_content: str = text_content


class DocumentConverter:
    &#34;&#34;&#34;Abstract superclass of all DocumentConverters.&#34;&#34;&#34;

    def convert(
        self, local_path: str, **kwargs: Any
    ) -&gt; Union[None, DocumentConverterResult]:
        raise NotImplementedError()


class PlainTextConverter(DocumentConverter):
    &#34;&#34;&#34;Anything with content type text/plain&#34;&#34;&#34;

    def convert(
        self, local_path: str, **kwargs: Any
    ) -&gt; Union[None, DocumentConverterResult]:
        # Guess the content type from any file extension that might be around
        content_type, _ = mimetypes.guess_type(
            &#34;__placeholder&#34; &#43; kwargs.get(&#34;file_extension&#34;, &#34;&#34;)
        )

        # Only accept text files
        if content_type is None:
            return None
        elif &#34;text/&#34; not in content_type.lower():
            return None

        text_content = str(from_path(local_path).best())
        return DocumentConverterResult(
            title=None,
            text_content=text_content,
        )


class HtmlConverter(DocumentConverter):
    &#34;&#34;&#34;Anything with content type text/html&#34;&#34;&#34;

    def convert(
        self, local_path: str, **kwargs: Any
    ) -&gt; Union[None, DocumentConverterResult]:
        # Bail if not html
        extension = kwargs.get(&#34;file_extension&#34;, &#34;&#34;)
        if extension.lower() not in [&#34;.html&#34;, &#34;.htm&#34;]:
            return None

        result = None
        with open(local_path, &#34;rt&#34;, encoding=&#34;utf-8&#34;) as fh:
            result = self._convert(fh.read())

        return result

    def _convert(self, html_content: str) -&gt; Union[None, DocumentConverterResult]:
        &#34;&#34;&#34;Helper function that converts and HTML string.&#34;&#34;&#34;

        # Parse the string
        soup = BeautifulSoup(html_content, &#34;html.parser&#34;)

        # Remove javascript and style blocks
        for script in soup([&#34;script&#34;, &#34;style&#34;]):
            script.extract()

        # Print only the main content
        body_elm = soup.find(&#34;body&#34;)
        webpage_text = &#34;&#34;
        if body_elm:
            webpage_text = _CustomMarkdownify().convert_soup(body_elm)
        else:
            webpage_text = _CustomMarkdownify().convert_soup(soup)

        assert isinstance(webpage_text, str)

        return DocumentConverterResult(
            title=None if soup.title is None else soup.title.string,
            text_content=webpage_text,
        )


class WikipediaConverter(DocumentConverter):
    &#34;&#34;&#34;Handle Wikipedia pages separately, focusing only on the main document content.&#34;&#34;&#34;

    def convert(
        self, local_path: str, **kwargs: Any
    ) -&gt; Union[None, DocumentConverterResult]:
        # Bail if not Wikipedia
        extension = kwargs.get(&#34;file_extension&#34;, &#34;&#34;)
        if extension.lower() not in [&#34;.html&#34;, &#34;.htm&#34;]:
            return None
        url = kwargs.get(&#34;url&#34;, &#34;&#34;)
        if not re.search(r&#34;^https?:\/\/[a-zA-Z]{2,3}\.wikipedia.org\/&#34;, url):
            return None

        # Parse the file
        soup = None
        with open(local_path, &#34;rt&#34;, encoding=&#34;utf-8&#34;) as fh:
            soup = BeautifulSoup(fh.read(), &#34;html.parser&#34;)

        # Remove javascript and style blocks
        for script in soup([&#34;script&#34;, &#34;style&#34;]):
            script.extract()

        # Print only the main content
        body_elm = soup.find(&#34;div&#34;, {&#34;id&#34;: &#34;mw-content-text&#34;})
        title_elm = soup.find(&#34;span&#34;, {&#34;class&#34;: &#34;mw-page-title-main&#34;})

        webpage_text = &#34;&#34;
        main_title = None if soup.title is None else soup.title.string

        if body_elm:
            # What&#39;s the title
            if title_elm and len(title_elm) &gt; 0:
                main_title = title_elm.string  # type: ignore
                assert isinstance(main_title, str)

            # Convert the page
            webpage_text = f&#34;# {main_title}\n\n&#34; &#43; _CustomMarkdownify().convert_soup(
                body_elm
            )
        else:
            webpage_text = _CustomMarkdownify().convert_soup(soup)

        return DocumentConverterResult(
            title=main_title,
            text_content=webpage_text,
        )


class YouTubeConverter(DocumentConverter):
    &#34;&#34;&#34;Handle YouTube specially, focusing on the video title, description, and transcript.&#34;&#34;&#34;

    def convert(
        self, local_path: str, **kwargs: Any
    ) -&gt; Union[None, DocumentConverterResult]:
        # Bail if not YouTube
        extension = kwargs.get(&#34;file_extension&#34;, &#34;&#34;)
        if extension.lower() not in [&#34;.html&#34;, &#34;.htm&#34;]:
            return None
        url = kwargs.get(&#34;url&#34;, &#34;&#34;)
        if not url.startswith(&#34;https://www.youtube.com/watch?&#34;):
            return None

        # Parse the file
        soup = None
        with open(local_path, &#34;rt&#34;, encoding=&#34;utf-8&#34;) as fh:
            soup = BeautifulSoup(fh.read(), &#34;html.parser&#34;)

        # Read the meta tags
        assert soup.title is not None and soup.title.string is not None
        metadata: Dict[str, str] = {&#34;title&#34;: soup.title.string}
        for meta in soup([&#34;meta&#34;]):
            for a in meta.attrs:
                if a in [&#34;itemprop&#34;, &#34;property&#34;, &#34;name&#34;]:
                    metadata[meta[a]] = meta.get(&#34;content&#34;, &#34;&#34;)
                    break

        # We can also try to read the full description. This is more prone to breaking, since it reaches into the page implementation
        try:
            for script in soup([&#34;script&#34;]):
                content = script.text
                if &#34;ytInitialData&#34; in content:
                    lines = re.split(r&#34;\r?\n&#34;, content)
                    obj_start = lines[0].find(&#34;{&#34;)
                    obj_end = lines[0].rfind(&#34;}&#34;)
                    if obj_start &gt;= 0 and obj_end &gt;= 0:
                        data = json.loads(lines[0][obj_start : obj_end &#43; 1])
                        attrdesc = self._findKey(data, &#34;attributedDescriptionBodyText&#34;)  # type: ignore
                        if attrdesc:
                            metadata[&#34;description&#34;] = str(attrdesc[&#34;content&#34;])
                    break
        except Exception:
            pass

        # Start preparing the page
        webpage_text = &#34;# YouTube\n&#34;

        title = self._get(metadata, [&#34;title&#34;, &#34;og:title&#34;, &#34;name&#34;])  # type: ignore
        assert isinstance(title, str)

        if title:
            webpage_text &#43;= f&#34;\n## {title}\n&#34;

        stats = &#34;&#34;
        views = self._get(metadata, [&#34;interactionCount&#34;])  # type: ignore
        if views:
            stats &#43;= f&#34;- **Views:** {views}\n&#34;

        keywords = self._get(metadata, [&#34;keywords&#34;])  # type: ignore
        if keywords:
            stats &#43;= f&#34;- **Keywords:** {keywords}\n&#34;

        runtime = self._get(metadata, [&#34;duration&#34;])  # type: ignore
        if runtime:
            stats &#43;= f&#34;- **Runtime:** {runtime}\n&#34;

        if len(stats) &gt; 0:
            webpage_text &#43;= f&#34;\n### Video Metadata\n{stats}\n&#34;

        description = self._get(metadata, [&#34;description&#34;, &#34;og:description&#34;])  # type: ignore
        if description:
            webpage_text &#43;= f&#34;\n### Description\n{description}\n&#34;

        if IS_YOUTUBE_TRANSCRIPT_CAPABLE:
            transcript_text = &#34;&#34;
            parsed_url = urlparse(url)  # type: ignore
            params = parse_qs(parsed_url.query)  # type: ignore
            if &#34;v&#34; in params:
                assert isinstance(params[&#34;v&#34;][0], str)
                video_id = str(params[&#34;v&#34;][0])
                try:
                    youtube_transcript_languages = kwargs.get(
                        &#34;youtube_transcript_languages&#34;, (&#34;en&#34;,)
                    )
                    # Must be a single transcript.
                    transcript = YouTubeTranscriptApi.get_transcript(video_id, languages=youtube_transcript_languages)  # type: ignore
                    transcript_text = &#34; &#34;.join([part[&#34;text&#34;] for part in transcript])  # type: ignore
                    # Alternative formatting:
                    # formatter = TextFormatter()
                    # formatter.format_transcript(transcript)
                except Exception:
                    pass
            if transcript_text:
                webpage_text &#43;= f&#34;\n### Transcript\n{transcript_text}\n&#34;

        title = title if title else soup.title.string
        assert isinstance(title, str)

        return DocumentConverterResult(
            title=title,
            text_content=webpage_text,
        )

    def _get(
        self,
        metadata: Dict[str, str],
        keys: List[str],
        default: Union[str, None] = None,
    ) -&gt; Union[str, None]:
        for k in keys:
            if k in metadata:
                return metadata[k]
        return default

    def _findKey(self, json: Any, key: str) -&gt; Union[str, None]:  # TODO: Fix json type
        if isinstance(json, list):
            for elm in json:
                ret = self._findKey(elm, key)
                if ret is not None:
                    return ret
        elif isinstance(json, dict):
            for k in json:
                if k == key:
                    return json[k]
                else:
                    ret = self._findKey(json[k], key)
                    if ret is not None:
                        return ret
        return None


class BingSerpConverter(DocumentConverter):
    &#34;&#34;&#34;
    Handle Bing results pages (only the organic search results).
    NOTE: It is better to use the Bing API
    &#34;&#34;&#34;

    def convert(self, local_path, **kwargs) -&gt; Union[None, DocumentConverterResult]:
        # Bail if not a Bing SERP
        extension = kwargs.get(&#34;file_extension&#34;, &#34;&#34;)
        if extension.lower() not in [&#34;.html&#34;, &#34;.htm&#34;]:
            return None
        url = kwargs.get(&#34;url&#34;, &#34;&#34;)
        if not re.search(r&#34;^https://www\.bing\.com/search\?q=&#34;, url):
            return None

        # Parse the query parameters
        parsed_params = parse_qs(urlparse(url).query)
        query = parsed_params.get(&#34;q&#34;, [&#34;&#34;])[0]

        # Parse the file
        soup = None
        with open(local_path, &#34;rt&#34;, encoding=&#34;utf-8&#34;) as fh:
            soup = BeautifulSoup(fh.read(), &#34;html.parser&#34;)

        # Clean up some formatting
        for tptt in soup.find_all(class_=&#34;tptt&#34;):
            if hasattr(tptt, &#34;string&#34;) and tptt.string:
                tptt.string &#43;= &#34; &#34;
        for slug in soup.find_all(class_=&#34;algoSlug_icon&#34;):
            slug.extract()

        # Parse the algorithmic results
        _markdownify = _CustomMarkdownify()
        results = list()
        for result in soup.find_all(class_=&#34;b_algo&#34;):
            # Rewrite redirect urls
            for a in result.find_all(&#34;a&#34;, href=True):
                parsed_href = urlparse(a[&#34;href&#34;])
                qs = parse_qs(parsed_href.query)

                # The destination is contained in the u parameter,
                # but appears to be base64 encoded, with some prefix
                if &#34;u&#34; in qs:
                    u = (
                        qs[&#34;u&#34;][0][2:].strip() &#43; &#34;==&#34;
                    )  # Python 3 doesn&#39;t care about extra padding

                    try:
                        # RFC 4648 / Base64URL&#34; variant, which uses &#34;-&#34; and &#34;_&#34;
                        a[&#34;href&#34;] = base64.b64decode(u, altchars=&#34;-_&#34;).decode(&#34;utf-8&#34;)
                    except UnicodeDecodeError:
                        pass
                    except binascii.Error:
                        pass

            # Convert to markdown
            md_result = _markdownify.convert_soup(result).strip()
            lines = [line.strip() for line in re.split(r&#34;\n&#43;&#34;, md_result)]
            results.append(&#34;\n&#34;.join([line for line in lines if len(line) &gt; 0]))

        webpage_text = (
            f&#34;## A Bing search for &#39;{query}&#39; found the following results:\n\n&#34;
            &#43; &#34;\n\n&#34;.join(results)
        )

        return DocumentConverterResult(
            title=None if soup.title is None else soup.title.string,
            text_content=webpage_text,
        )


class PdfConverter(DocumentConverter):
    &#34;&#34;&#34;
    Converts PDFs to Markdown. Most style information is ignored, so the results are essentially plain-text.
    &#34;&#34;&#34;

    def convert(self, local_path, **kwargs) -&gt; Union[None, DocumentConverterResult]:
        llm_client= kwargs.get(&#34;llm_client&#34;, None)
        llm_model = kwargs.get(&#34;llm_model&#34;, None)
        llm_prompt = kwargs.get(&#34;llm_prompt&#34;, None)
        customMammothCoverImage = CustomMammothCoverImage(llm_client, llm_model, llm_prompt, &#39;pdf&#39;)

        # Bail if not a PDF
        extension = kwargs.get(&#34;file_extension&#34;, &#34;&#34;)
        if extension.lower() != &#34;.pdf&#34;:
            return None

        # 使用 PyMuPDF 打开指定路径的 PDF 文件
        doc = fitz.open(local_path)
        content_items = []

        # 遍历 PDF 文件中的每一页
        for page_num in range(len(doc)):
            page_content = []
            # 加载当前页的内容
            page = doc.load_page(page_num)

            # 提取带有位置信息的文本块
            text_blocks = page.get_text(&#34;blocks&#34;)
            # 提取页面上的所有图像对象，并获取它们的边界框信息
            image_list = page.get_images(full=True)

            # 收集文本项
            for tb in text_blocks:
                rect = (tb[0], tb[1], tb[2], tb[3])  # Text block rectangle
                page_content.append({
                    &#39;type&#39;: &#39;text&#39;,
                    &#39;content&#39;: tb[4],   # 文本内容
                    &#39;rect&#39;: rect    # 文本块的位置信息
                })

            # 收集图像项
            for img_index, img in enumerate(image_list):
                xref = img[0]
                base_image = doc.extract_image(xref)
                image_bytes = base_image[&#34;image&#34;]
                image_ext = base_image[&#34;ext&#34;]
                # 调用豆包识别图片信息
                result = customMammothCoverImage.mammoth_convert_image(base_image)

                # Approximate the image&#39;s position using its bounding box
                image_rect = page.get_image_bbox(img)
                page_content.append({
                    &#39;type&#39;: &#39;image&#39;,
                    &#39;content&#39;: result[&#39;alt&#39;],
                    &#39;rect&#39;: image_rect  # 获取图像的大致位置
                })

            # 根据内容项在页面上的垂直位置（y坐标），然后是水平位置（x坐标）对它们进行排序
            page_content.sort(key=lambda item: (item[&#39;rect&#39;][1], item[&#39;rect&#39;][0]))
            content_items.extend(page_content)

        # 遍历排好序的内容项,只要content
        str = &#34;&#34;
        for info in content_items:
            str = str &#43; info[&#34;content&#34;]

        return DocumentConverterResult(
            title=None,
            text_content=str,
            # text_content=pdfminer.high_level.extract_text(local_path),
        )




class CustomMammothCoverImage:
  def __init__(self,llm_client: Optional[Any] = None,llm_model: Optional[str] = None,llm_prompt: Optional[str] = None,type: Optional[str] = None):
        self.llm_client=llm_client
        self.llm_model = llm_model
        self.llm_prompt = llm_prompt
        self.type = type
        self.custom_image_converter = mammoth.images.img_element(self.mammoth_convert_image)
        self.mdImage = MarkItDown(llm_client=llm_client, llm_model=llm_model)

  def mammoth_convert_image(self, image):
        output_dir = &#34;./static/temp&#34;
        # 确保输出目录存在
        os.makedirs(output_dir, exist_ok=True)

        # 获取文件后缀
        if self.type == &#39;docx&#39; or self.type == &#39;pptx&#39;:
            content_type = image.content_type.lower()
        elif self.type == &#39;pdf&#39;:
            content_type = image[&#34;ext&#34;].lower()

        # 根据 content_type 创建合适的文件扩展名
        if &#34;png&#34; in content_type:
            extension = &#34;.png&#34;
        elif &#34;jpeg&#34; in content_type or &#34;jpg&#34; in content_type:
            extension = &#34;.jpg&#34;
        else:
            extension = &#34;.bin&#34;  # 如果类型未知，使用 .bin 扩展名

        # 构造唯一的文件名，避免覆盖已有的文件
        # 图片名称: uuid &#43; 后缀
        imageName = uuid.uuid4().hex &#43; extension
        filename = os.path.join(output_dir, imageName)
        i = 1
        while os.path.exists(filename):
            filename = os.path.join(output_dir, f&#34;image_{i}{extension}&#34;)
            i &#43;= 1

        # 打开图像并写入文件
        if self.type == &#39;docx&#39;:
            # doc
            with image.open() as image_bytes:
                with open(filename, &#39;wb&#39;) as file:
                    file.write(image_bytes.read())
        elif self.type == &#39;pptx&#39;:
            # ppt
            with open(filename, &#39;wb&#39;) as f:
                f.write(image.blob)
        elif self.type == &#39;pdf&#39;:
            # pdf
            with open(filename, &#39;wb&#39;) as f:
                f.write(image[&#34;image&#34;])

        result = self.mdImage.convert(filename,llm_prompt=self.llm_prompt)
        #print(self.llm_client)
        # 最后删除这个图片
        os.remove(filename)
        return {
            &#34;alt&#34;: result.text_content
        }





class DocxConverter(HtmlConverter):

    &#34;&#34;&#34;
    Converts DOCX files to Markdown. Style information (e.g.m headings) and tables are preserved where possible.
    &#34;&#34;&#34;

    def convert(self, local_path, **kwargs) -&gt; Union[None, DocumentConverterResult]:

        llm_client= kwargs.get(&#34;llm_client&#34;, None)
        llm_model = kwargs.get(&#34;llm_model&#34;, None)
        llm_prompt = kwargs.get(&#34;llm_prompt&#34;, None)
        customMammothCoverImage= CustomMammothCoverImage(llm_client,llm_model,llm_prompt,&#39;docx&#39;)

        # Bail if not a DOCX
        extension = kwargs.get(&#34;file_extension&#34;, &#34;&#34;)
        if extension.lower() != &#34;.docx&#34;:
            return None

        result = None
        with open(local_path, &#34;rb&#34;) as docx_file:
            style_map = kwargs.get(&#34;style_map&#34;, None)
            result = mammoth.convert_to_html(docx_file, style_map=style_map,convert_image=customMammothCoverImage.custom_image_converter)
            html_content = result.value
            result = self._convert(html_content)

        return result


class XlsxConverter(HtmlConverter):
    &#34;&#34;&#34;
    Converts XLSX files to Markdown, with each sheet presented as a separate Markdown table.
    &#34;&#34;&#34;

    def convert(self, local_path, **kwargs) -&gt; Union[None, DocumentConverterResult]:
        # Bail if not a XLSX
        extension = kwargs.get(&#34;file_extension&#34;, &#34;&#34;)
        if extension.lower() != &#34;.xlsx&#34;:
            return None

        sheets = pd.read_excel(local_path, sheet_name=None)
        md_content = &#34;&#34;
        for s in sheets:
            md_content &#43;= f&#34;## {s}\n&#34;
            html_content = sheets[s].to_html(index=False)
            md_content &#43;= self._convert(html_content).text_content.strip() &#43; &#34;\n\n&#34;

        return DocumentConverterResult(
            title=None,
            text_content=md_content.strip(),
        )


class PptxConverter(HtmlConverter):
    &#34;&#34;&#34;
    Converts PPTX files to Markdown. Supports heading, tables and images with alt text.
    &#34;&#34;&#34;

    def convert(self, local_path, **kwargs) -&gt; Union[None, DocumentConverterResult]:
        llm_client= kwargs.get(&#34;llm_client&#34;, None)
        llm_model = kwargs.get(&#34;llm_model&#34;, None)
        llm_prompt = kwargs.get(&#34;llm_prompt&#34;, None)
        customMammothCoverImage = CustomMammothCoverImage(llm_client, llm_model, llm_prompt, &#39;pptx&#39;)

        # Bail if not a PPTX
        extension = kwargs.get(&#34;file_extension&#34;, &#34;&#34;)
        if extension.lower() != &#34;.pptx&#34;:
            return None

        md_content = &#34;&#34;

        presentation = pptx.Presentation(local_path)
        slide_num = 0
        for slide in presentation.slides:
            slide_num &#43;= 1

            md_content &#43;= f&#34;\n\n&lt;!-- Slide number: {slide_num} --&gt;\n&#34;

            title = slide.shapes.title
            for shape in slide.shapes:
                # Pictures
                if self._is_picture(shape):
                    # https://github.com/scanny/python-pptx/pull/512#issuecomment-1713100069
                    alt_text = &#34;&#34;
                    try:
                        alt_text = shape._element._nvXxPr.cNvPr.attrib.get(&#34;descr&#34;, &#34;&#34;)
                    except Exception:
                        pass
                    # print(shape.image)
                    result = customMammothCoverImage.mammoth_convert_image(shape.image)

                    # A placeholder name
                    filename = re.sub(r&#34;\W&#34;, &#34;&#34;, shape.name) &#43; &#34;.jpg&#34;
                    # md_content &#43;= (
                    #     &#34;\n![&#34;
                    #     &#43; (alt_text if alt_text else shape.name)
                    #     &#43; &#34;](&#34;
                    #     &#43; filename
                    #     &#43; &#34;)\n&#34;
                    # )
                    md_content &#43;= (
                        &#34;\n![&#34;
                        &#43; result[&#39;alt&#39;]
                        &#43; &#34;](&#34;
                        &#43; &#34;)\n&#34;
                    )

                # Tables
                if self._is_table(shape):
                    html_table = &#34;&lt;html&gt;&lt;body&gt;&lt;table&gt;&#34;
                    first_row = True
                    for row in shape.table.rows:
                        html_table &#43;= &#34;&lt;tr&gt;&#34;
                        for cell in row.cells:
                            if first_row:
                                html_table &#43;= &#34;&lt;th&gt;&#34; &#43; html.escape(cell.text) &#43; &#34;&lt;/th&gt;&#34;
                            else:
                                html_table &#43;= &#34;&lt;td&gt;&#34; &#43; html.escape(cell.text) &#43; &#34;&lt;/td&gt;&#34;
                        html_table &#43;= &#34;&lt;/tr&gt;&#34;
                        first_row = False
                    html_table &#43;= &#34;&lt;/table&gt;&lt;/body&gt;&lt;/html&gt;&#34;
                    md_content &#43;= (
                        &#34;\n&#34; &#43; self._convert(html_table).text_content.strip() &#43; &#34;\n&#34;
                    )

                # Charts
                if shape.has_chart:
                    md_content &#43;= self._convert_chart_to_markdown(shape.chart)

                # Text areas
                elif shape.has_text_frame:
                    if shape == title:
                        md_content &#43;= &#34;# &#34; &#43; shape.text.lstrip() &#43; &#34;\n&#34;
                    else:
                        md_content &#43;= shape.text &#43; &#34;\n&#34;

            md_content = md_content.strip()

            if slide.has_notes_slide:
                md_content &#43;= &#34;\n\n### Notes:\n&#34;
                notes_frame = slide.notes_slide.notes_text_frame
                if notes_frame is not None:
                    md_content &#43;= notes_frame.text
                md_content = md_content.strip()

        return DocumentConverterResult(
            title=None,
            text_content=md_content.strip(),
        )

    def _is_picture(self, shape):
        if shape.shape_type == pptx.enum.shapes.MSO_SHAPE_TYPE.PICTURE:
            return True
        if shape.shape_type == pptx.enum.shapes.MSO_SHAPE_TYPE.PLACEHOLDER:
            if hasattr(shape, &#34;image&#34;):
                return True
        return False

    def _is_table(self, shape):
        if shape.shape_type == pptx.enum.shapes.MSO_SHAPE_TYPE.TABLE:
            return True
        return False

    def _convert_chart_to_markdown(self, chart):
        md = &#34;\n\n### Chart&#34;
        if chart.has_title:
            md &#43;= f&#34;: {chart.chart_title.text_frame.text}&#34;
        md &#43;= &#34;\n\n&#34;
        data = []
        category_names = [c.label for c in chart.plots[0].categories]
        series_names = [s.name for s in chart.series]
        data.append([&#34;Category&#34;] &#43; series_names)

        for idx, category in enumerate(category_names):
            row = [category]
            for series in chart.series:
                row.append(series.values[idx])
            data.append(row)

        markdown_table = []
        for row in data:
            markdown_table.append(&#34;| &#34; &#43; &#34; | &#34;.join(map(str, row)) &#43; &#34; |&#34;)
        header = markdown_table[0]
        separator = &#34;|&#34; &#43; &#34;|&#34;.join([&#34;---&#34;] * len(data[0])) &#43; &#34;|&#34;
        return md &#43; &#34;\n&#34;.join([header, separator] &#43; markdown_table[1:])


class MediaConverter(DocumentConverter):
    &#34;&#34;&#34;
    Abstract class for multi-modal media (e.g., images and audio)
    &#34;&#34;&#34;

    def _get_metadata(self, local_path):
        exiftool = shutil.which(&#34;exiftool&#34;)
        if not exiftool:
            return None
        else:
            try:
                result = subprocess.run(
                    [exiftool, &#34;-json&#34;, local_path], capture_output=True, text=True
                ).stdout
                return json.loads(result)[0]
            except Exception:
                return None


class WavConverter(MediaConverter):
    &#34;&#34;&#34;
    Converts WAV files to markdown via extraction of metadata (if `exiftool` is installed), and speech transcription (if `speech_recognition` is installed).
    &#34;&#34;&#34;

    def convert(self, local_path, **kwargs) -&gt; Union[None, DocumentConverterResult]:
        # Bail if not a XLSX
        extension = kwargs.get(&#34;file_extension&#34;, &#34;&#34;)
        if extension.lower() != &#34;.wav&#34;:
            return None

        md_content = &#34;&#34;

        # Add metadata
        metadata = self._get_metadata(local_path)
        if metadata:
            for f in [
                &#34;Title&#34;,
                &#34;Artist&#34;,
                &#34;Author&#34;,
                &#34;Band&#34;,
                &#34;Album&#34;,
                &#34;Genre&#34;,
                &#34;Track&#34;,
                &#34;DateTimeOriginal&#34;,
                &#34;CreateDate&#34;,
                &#34;Duration&#34;,
            ]:
                if f in metadata:
                    md_content &#43;= f&#34;{f}: {metadata[f]}\n&#34;

        # Transcribe
        if IS_AUDIO_TRANSCRIPTION_CAPABLE:
            try:
                transcript = self._transcribe_audio(local_path)
                md_content &#43;= &#34;\n\n### Audio Transcript:\n&#34; &#43; (
                    &#34;[No speech detected]&#34; if transcript == &#34;&#34; else transcript
                )
            except Exception:
                md_content &#43;= (
                    &#34;\n\n### Audio Transcript:\nError. Could not transcribe this audio.&#34;
                )

        return DocumentConverterResult(
            title=None,
            text_content=md_content.strip(),
        )

    def _transcribe_audio(self, local_path) -&gt; str:
        recognizer = sr.Recognizer()
        with sr.AudioFile(local_path) as source:
            audio = recognizer.record(source)
            return recognizer.recognize_google(audio).strip()


class Mp3Converter(WavConverter):
    &#34;&#34;&#34;
    Converts MP3 files to markdown via extraction of metadata (if `exiftool` is installed), and speech transcription (if `speech_recognition` AND `pydub` are installed).
    &#34;&#34;&#34;

    def convert(self, local_path, **kwargs) -&gt; Union[None, DocumentConverterResult]:
        # Bail if not a MP3
        extension = kwargs.get(&#34;file_extension&#34;, &#34;&#34;)
        if extension.lower() != &#34;.mp3&#34;:
            return None

        md_content = &#34;&#34;

        # Add metadata
        metadata = self._get_metadata(local_path)
        if metadata:
            for f in [
                &#34;Title&#34;,
                &#34;Artist&#34;,
                &#34;Author&#34;,
                &#34;Band&#34;,
                &#34;Album&#34;,
                &#34;Genre&#34;,
                &#34;Track&#34;,
                &#34;DateTimeOriginal&#34;,
                &#34;CreateDate&#34;,
                &#34;Duration&#34;,
            ]:
                if f in metadata:
                    md_content &#43;= f&#34;{f}: {metadata[f]}\n&#34;

        # Transcribe
        if IS_AUDIO_TRANSCRIPTION_CAPABLE:
            handle, temp_path = tempfile.mkstemp(suffix=&#34;.wav&#34;)
            os.close(handle)
            try:
                sound = pydub.AudioSegment.from_mp3(local_path)
                sound.export(temp_path, format=&#34;wav&#34;)

                _args = dict()
                _args.update(kwargs)
                _args[&#34;file_extension&#34;] = &#34;.wav&#34;

                try:
                    transcript = super()._transcribe_audio(temp_path).strip()
                    md_content &#43;= &#34;\n\n### Audio Transcript:\n&#34; &#43; (
                        &#34;[No speech detected]&#34; if transcript == &#34;&#34; else transcript
                    )
                except Exception:
                    md_content &#43;= &#34;\n\n### Audio Transcript:\nError. Could not transcribe this audio.&#34;

            finally:
                os.unlink(temp_path)

        # Return the result
        return DocumentConverterResult(
            title=None,
            text_content=md_content.strip(),
        )


class ImageConverter(MediaConverter):
    &#34;&#34;&#34;
    Converts images to markdown via extraction of metadata (if `exiftool` is installed), OCR (if `easyocr` is installed), and description via a multimodal LLM (if an llm_client is configured).
    &#34;&#34;&#34;

    def convert(self, local_path, **kwargs) -&gt; Union[None, DocumentConverterResult]:
        # Bail if not a XLSX
        extension = kwargs.get(&#34;file_extension&#34;, &#34;&#34;)
        if extension.lower() not in [&#34;.jpg&#34;, &#34;.jpeg&#34;, &#34;.png&#34;]:
            return None

        md_content = &#34;&#34;

        # Add metadata
        metadata = self._get_metadata(local_path)
        if metadata:
            for f in [
                &#34;ImageSize&#34;,
                &#34;Title&#34;,
                &#34;Caption&#34;,
                &#34;Description&#34;,
                &#34;Keywords&#34;,
                &#34;Artist&#34;,
                &#34;Author&#34;,
                &#34;DateTimeOriginal&#34;,
                &#34;CreateDate&#34;,
                &#34;GPSPosition&#34;,
            ]:
                if f in metadata:
                    md_content &#43;= f&#34;{f}: {metadata[f]}\n&#34;

        # Try describing the image with GPTV
        llm_client = kwargs.get(&#34;llm_client&#34;)
        llm_model = kwargs.get(&#34;llm_model&#34;)
        if llm_client is not None and llm_model is not None:
            md_content &#43;= (
                &#34;\n# Description:\n&#34;
                &#43; self._get_llm_description(
                    local_path,
                    extension,
                    llm_client,
                    llm_model,
                    prompt=kwargs.get(&#34;llm_prompt&#34;),
                ).strip()
                &#43; &#34;\n&#34;
            )

        return DocumentConverterResult(
            title=None,
            text_content=md_content,
        )

    def _get_llm_description(self, local_path, extension, client, model, prompt=None):
        if prompt is None or prompt.strip() == &#34;&#34;:
            prompt = &#34;Write a detailed caption for this image.&#34;

        data_uri = &#34;&#34;
        with open(local_path, &#34;rb&#34;) as image_file:
            content_type, encoding = mimetypes.guess_type(&#34;_dummy&#34; &#43; extension)
            if content_type is None:
                content_type = &#34;image/jpeg&#34;
            image_base64 = base64.b64encode(image_file.read()).decode(&#34;utf-8&#34;)
            data_uri = f&#34;data:{content_type};base64,{image_base64}&#34;

        messages = [
            {
                &#34;role&#34;: &#34;user&#34;,
                &#34;content&#34;: [
                    {&#34;type&#34;: &#34;text&#34;, &#34;text&#34;: prompt},
                    {
                        &#34;type&#34;: &#34;image_url&#34;,
                        &#34;image_url&#34;: {
                            &#34;url&#34;: data_uri,
                        },
                    },
                ],
            }
        ]

        response = client.chat.completions.create(model=model, messages=messages)
        return response.choices[0].message.content


class ZipConverter(DocumentConverter):
    &#34;&#34;&#34;Converts ZIP files to markdown by extracting and converting all contained files.

    The converter extracts the ZIP contents to a temporary directory, processes each file
    using appropriate converters based on file extensions, and then combines the results
    into a single markdown document. The temporary directory is cleaned up after processing.

    Example output format:
    ```markdown
    Content from the zip file `example.zip`:

    ## File: docs/readme.txt

    This is the content of readme.txt
    Multiple lines are preserved

    ## File: images/example.jpg

    ImageSize: 1920x1080
    DateTimeOriginal: 2024-02-15 14:30:00
    Description: A beautiful landscape photo

    ## File: data/report.xlsx

    ## Sheet1
    | Column1 | Column2 | Column3 |
    |---------|---------|---------|
    | data1   | data2   | data3   |
    | data4   | data5   | data6   |
    ```

    Key features:
    - Maintains original file structure in headings
    - Processes nested files recursively
    - Uses appropriate converters for each file type
    - Preserves formatting of converted content
    - Cleans up temporary files after processing
    &#34;&#34;&#34;

    def convert(
        self, local_path: str, **kwargs: Any
    ) -&gt; Union[None, DocumentConverterResult]:
        # Bail if not a ZIP
        extension = kwargs.get(&#34;file_extension&#34;, &#34;&#34;)
        if extension.lower() != &#34;.zip&#34;:
            return None

        # Get parent converters list if available
        parent_converters = kwargs.get(&#34;_parent_converters&#34;, [])
        if not parent_converters:
            return DocumentConverterResult(
                title=None,
                text_content=f&#34;[ERROR] No converters available to process zip contents from: {local_path}&#34;,
            )

        extracted_zip_folder_name = (
            f&#34;extracted_{os.path.basename(local_path).replace(&#39;.zip&#39;, &#39;_zip&#39;)}&#34;
        )
        new_folder = os.path.normpath(
            os.path.join(os.path.dirname(local_path), extracted_zip_folder_name)
        )
        md_content = f&#34;Content from the zip file `{os.path.basename(local_path)}`:\n\n&#34;

        # Safety check for path traversal
        if not new_folder.startswith(os.path.dirname(local_path)):
            return DocumentConverterResult(
                title=None, text_content=f&#34;[ERROR] Invalid zip file path: {local_path}&#34;
            )

        try:
            # Extract the zip file
            with zipfile.ZipFile(local_path, &#34;r&#34;) as zipObj:
                zipObj.extractall(path=new_folder)

            # Process each extracted file
            for root, dirs, files in os.walk(new_folder):
                for name in files:
                    file_path = os.path.join(root, name)
                    relative_path = os.path.relpath(file_path, new_folder)

                    # Get file extension
                    _, file_extension = os.path.splitext(name)

                    # Update kwargs for the file
                    file_kwargs = kwargs.copy()
                    file_kwargs[&#34;file_extension&#34;] = file_extension
                    file_kwargs[&#34;_parent_converters&#34;] = parent_converters

                    # Try converting the file using available converters
                    for converter in parent_converters:
                        # Skip the zip converter to avoid infinite recursion
                        if isinstance(converter, ZipConverter):
                            continue

                        result = converter.convert(file_path, **file_kwargs)
                        if result is not None:
                            md_content &#43;= f&#34;\n## File: {relative_path}\n\n&#34;
                            md_content &#43;= result.text_content &#43; &#34;\n\n&#34;
                            break

            # Clean up extracted files if specified
            if kwargs.get(&#34;cleanup_extracted&#34;, True):
                shutil.rmtree(new_folder)

            return DocumentConverterResult(title=None, text_content=md_content.strip())

        except zipfile.BadZipFile:
            return DocumentConverterResult(
                title=None,
                text_content=f&#34;[ERROR] Invalid or corrupted zip file: {local_path}&#34;,
            )
        except Exception as e:
            return DocumentConverterResult(
                title=None,
                text_content=f&#34;[ERROR] Failed to process zip file {local_path}: {str(e)}&#34;,
            )


class FileConversionException(BaseException):
    pass


class UnsupportedFormatException(BaseException):
    pass


class MarkItDown:
    &#34;&#34;&#34;(In preview) An extremely simple text-based document reader, suitable for LLM use.
    This reader will convert common file-types or webpages to Markdown.&#34;&#34;&#34;

    def __init__(
        self,
        requests_session: Optional[requests.Session] = None,
        llm_client: Optional[Any] = None,
        llm_model: Optional[str] = None,
        style_map: Optional[str] = None,
        # Deprecated
        mlm_client: Optional[Any] = None,
        mlm_model: Optional[str] = None,
    ):
        if requests_session is None:
            self._requests_session = requests.Session()
        else:
            self._requests_session = requests_session

        # Handle deprecation notices
        #############################
        if mlm_client is not None:
            if llm_client is None:
                warn(
                    &#34;&#39;mlm_client&#39; is deprecated, and was renamed &#39;llm_client&#39;.&#34;,
                    DeprecationWarning,
                )
                llm_client = mlm_client
                mlm_client = None
            else:
                raise ValueError(
                    &#34;&#39;mlm_client&#39; is deprecated, and was renamed &#39;llm_client&#39;. Do not use both at the same time. Just use &#39;llm_client&#39; instead.&#34;
                )

        if mlm_model is not None:
            if llm_model is None:
                warn(
                    &#34;&#39;mlm_model&#39; is deprecated, and was renamed &#39;llm_model&#39;.&#34;,
                    DeprecationWarning,
                )
                llm_model = mlm_model
                mlm_model = None
            else:
                raise ValueError(
                    &#34;&#39;mlm_model&#39; is deprecated, and was renamed &#39;llm_model&#39;. Do not use both at the same time. Just use &#39;llm_model&#39; instead.&#34;
                )
        #############################

        self._llm_client = llm_client
        self._llm_model = llm_model
        self._style_map = style_map

        self._page_converters: List[DocumentConverter] = []

        # Register converters for successful browsing operations
        # Later registrations are tried first / take higher priority than earlier registrations
        # To this end, the most specific converters should appear below the most generic converters
        self.register_page_converter(PlainTextConverter())
        self.register_page_converter(HtmlConverter())
        self.register_page_converter(WikipediaConverter())
        self.register_page_converter(YouTubeConverter())
        self.register_page_converter(BingSerpConverter())
        self.register_page_converter(DocxConverter())
        self.register_page_converter(XlsxConverter())
        self.register_page_converter(PptxConverter())
        self.register_page_converter(WavConverter())
        self.register_page_converter(Mp3Converter())
        self.register_page_converter(ImageConverter())
        self.register_page_converter(PdfConverter())
        self.register_page_converter(ZipConverter())

    def convert(
        self, source: Union[str, requests.Response], **kwargs: Any
    ) -&gt; DocumentConverterResult:  # TODO: deal with kwargs
        &#34;&#34;&#34;
        Args:
            - source: can be a string representing a path or url, or a requests.response object
            - extension: specifies the file extension to use when interpreting the file. If None, infer from source (path, uri, content-type, etc.)
        &#34;&#34;&#34;

        # Local path or url
        if isinstance(source, str):
            if (
                source.startswith(&#34;http://&#34;)
                or source.startswith(&#34;https://&#34;)
                or source.startswith(&#34;file://&#34;)
            ):
                return self.convert_url(source, **kwargs)
            else:
                return self.convert_local(source, **kwargs)
        # Request response
        elif isinstance(source, requests.Response):
            return self.convert_response(source, **kwargs)

    def convert_local(
        self, path: str, **kwargs: Any
    ) -&gt; DocumentConverterResult:  # TODO: deal with kwargs
        # Prepare a list of extensions to try (in order of priority)
        ext = kwargs.get(&#34;file_extension&#34;)
        extensions = [ext] if ext is not None else []

        # Get extension alternatives from the path and puremagic
        base, ext = os.path.splitext(path)
        self._append_ext(extensions, ext)

        for g in self._guess_ext_magic(path):
            self._append_ext(extensions, g)

        # Convert
        return self._convert(path, extensions, **kwargs)

    # TODO what should stream&#39;s type be?
    def convert_stream(
        self, stream: Any, **kwargs: Any
    ) -&gt; DocumentConverterResult:  # TODO: deal with kwargs
        # Prepare a list of extensions to try (in order of priority)
        ext = kwargs.get(&#34;file_extension&#34;)
        extensions = [ext] if ext is not None else []

        # Save the file locally to a temporary file. It will be deleted before this method exits
        handle, temp_path = tempfile.mkstemp()
        fh = os.fdopen(handle, &#34;wb&#34;)
        result = None
        try:
            # Write to the temporary file
            content = stream.read()
            if isinstance(content, str):
                fh.write(content.encode(&#34;utf-8&#34;))
            else:
                fh.write(content)
            fh.close()

            # Use puremagic to check for more extension options
            for g in self._guess_ext_magic(temp_path):
                self._append_ext(extensions, g)

            # Convert
            result = self._convert(temp_path, extensions, **kwargs)
        # Clean up
        finally:
            try:
                fh.close()
            except Exception:
                pass
            os.unlink(temp_path)

        return result

    def convert_url(
        self, url: str, **kwargs: Any
    ) -&gt; DocumentConverterResult:  # TODO: fix kwargs type
        # Send a HTTP request to the URL
        response = self._requests_session.get(url, stream=True)
        response.raise_for_status()
        return self.convert_response(response, **kwargs)

    def convert_response(
        self, response: requests.Response, **kwargs: Any
    ) -&gt; DocumentConverterResult:  # TODO fix kwargs type
        # Prepare a list of extensions to try (in order of priority)
        ext = kwargs.get(&#34;file_extension&#34;)
        extensions = [ext] if ext is not None else []

        # Guess from the mimetype
        content_type = response.headers.get(&#34;content-type&#34;, &#34;&#34;).split(&#34;;&#34;)[0]
        self._append_ext(extensions, mimetypes.guess_extension(content_type))

        # Read the content disposition if there is one
        content_disposition = response.headers.get(&#34;content-disposition&#34;, &#34;&#34;)
        m = re.search(r&#34;filename=([^;]&#43;)&#34;, content_disposition)
        if m:
            base, ext = os.path.splitext(m.group(1).strip(&#34;\&#34;&#39;&#34;))
            self._append_ext(extensions, ext)

        # Read from the extension from the path
        base, ext = os.path.splitext(urlparse(response.url).path)
        self._append_ext(extensions, ext)

        # Save the file locally to a temporary file. It will be deleted before this method exits
        handle, temp_path = tempfile.mkstemp()
        fh = os.fdopen(handle, &#34;wb&#34;)
        result = None
        try:
            # Download the file
            for chunk in response.iter_content(chunk_size=512):
                fh.write(chunk)
            fh.close()

            # Use puremagic to check for more extension options
            for g in self._guess_ext_magic(temp_path):
                self._append_ext(extensions, g)

            # Convert
            result = self._convert(temp_path, extensions, url=response.url, **kwargs)
        # Clean up
        finally:
            try:
                fh.close()
            except Exception:
                pass
            os.unlink(temp_path)

        return result

    def _convert(
        self, local_path: str, extensions: List[Union[str, None]], **kwargs
    ) -&gt; DocumentConverterResult:
        error_trace = &#34;&#34;
        for ext in extensions &#43; [None]:  # Try last with no extension
            for converter in self._page_converters:
                _kwargs = copy.deepcopy(kwargs)

                # Overwrite file_extension appropriately
                if ext is None:
                    if &#34;file_extension&#34; in _kwargs:
                        del _kwargs[&#34;file_extension&#34;]
                else:
                    _kwargs.update({&#34;file_extension&#34;: ext})

                # Copy any additional global options
                if &#34;llm_client&#34; not in _kwargs and self._llm_client is not None:
                    _kwargs[&#34;llm_client&#34;] = self._llm_client

                if &#34;llm_model&#34; not in _kwargs and self._llm_model is not None:
                    _kwargs[&#34;llm_model&#34;] = self._llm_model

                # Add the list of converters for nested processing
                _kwargs[&#34;_parent_converters&#34;] = self._page_converters

                if &#34;style_map&#34; not in _kwargs and self._style_map is not None:
                    _kwargs[&#34;style_map&#34;] = self._style_map

                # If we hit an error log it and keep trying
                try:
                    res = converter.convert(local_path, **_kwargs)
                except Exception:
                    error_trace = (&#34;\n\n&#34; &#43; traceback.format_exc()).strip()

                if res is not None:
                    # Normalize the content
                    res.text_content = &#34;\n&#34;.join(
                        [line.rstrip() for line in re.split(r&#34;\r?\n&#34;, res.text_content)]
                    )
                    res.text_content = re.sub(r&#34;\n{3,}&#34;, &#34;\n\n&#34;, res.text_content)

                    # Todo
                    return res

        # If we got this far without success, report any exceptions
        if len(error_trace) &gt; 0:
            raise FileConversionException(
                f&#34;Could not convert &#39;{local_path}&#39; to Markdown. File type was recognized as {extensions}. While converting the file, the following error was encountered:\n\n{error_trace}&#34;
            )

        # Nothing can handle it!
        raise UnsupportedFormatException(
            f&#34;Could not convert &#39;{local_path}&#39; to Markdown. The formats {extensions} are not supported.&#34;
        )

    def _append_ext(self, extensions, ext):
        &#34;&#34;&#34;Append a unique non-None, non-empty extension to a list of extensions.&#34;&#34;&#34;
        if ext is None:
            return
        ext = ext.strip()
        if ext == &#34;&#34;:
            return
        # if ext not in extensions:
        extensions.append(ext)

    def _guess_ext_magic(self, path):
        &#34;&#34;&#34;Use puremagic (a Python implementation of libmagic) to guess a file&#39;s extension based on the first few bytes.&#34;&#34;&#34;
        # Use puremagic to guess
        try:
            guesses = puremagic.magic_file(path)
            extensions = list()
            for g in guesses:
                ext = g.extension.strip()
                if len(ext) &gt; 0:
                    if not ext.startswith(&#34;.&#34;):
                        ext = &#34;.&#34; &#43; ext
                    if ext not in extensions:
                        extensions.append(ext)
            return extensions
        except FileNotFoundError:
            pass
        except IsADirectoryError:
            pass
        except PermissionError:
            pass
        return []

    def register_page_converter(self, converter: DocumentConverter) -&gt; None:
        &#34;&#34;&#34;Register a page text converter.&#34;&#34;&#34;
        self._page_converters.insert(0, converter)

```


## 杂

### 三元运算

``` python
status = 0 if a == &#34;xiaoming&#34; else 1
```

工作流程  

1.条件评估：首先计算条件 `a == &#34;xiaoming&#34;`。这将返回一个布尔值（`True` 或 `False`），取决于变量 `a` 是否等于字符串 `&#34;xiaoming&#34;`。

2.选择值：根据上述布尔值的结果来决定赋给 `status` 的值：
- 如果 `a == &#34;xiaoming&#34;` 返回 `True`，则 `status` 被赋予 `0`。
- 如果 `a == &#34;xiaoming&#34;` 返回 `False`，则 `status` 被赋予 `1`。

3.赋值操作：最终选定的值被赋给变量 `status。`



### 执行shell命令

``` python
import subprocess

async def test():
    # 设置环境变量
    os.environ[&#39;PATH&#39;] = &#39;/home/xxx/xxx/xxx:&#39; &#43; os.environ.get(&#39;PATH&#39;, &#39;&#39;)

    # 构建命令
    commands = f&#34;&#34;&#34;
        xxxxxxx &amp;&amp;
        xxxxxxx &amp;&amp;
        xxxxxxx &amp;&amp;
        xxxxxxx
    &#34;&#34;&#34;

    result = subprocess.run(
        commands,
        shell=True,
        executable=&#39;/bin/bash&#39;,
        check=True,
        stdout=subprocess.PIPE,
        stderr=subprocess.PIPE,
        encoding=&#39;utf-8&#39;
    )

    output = result.stdout
```


### 提取 md 文档中表格保存为csv文件

``` python
&#34;&#34;&#34;
markdown_text: md 文档内容
output_dir: csv 文件保存路径
&#34;&#34;&#34;

def extract_markdown_tables_to_csv(markdown_text: str, output_dir: str):
    # 确保输出目录存在
    if not os.path.exists(output_dir):
        os.makedirs(output_dir, exist_ok=True)

    # 使用正则表达式逐行匹配Markdown表格
    table_pattern = re.compile(r&#39;(?:\|.*)?(?:\n?\|.*(?:\|.*))&#43;&#39;, re.MULTILINE)

    tables = table_pattern.findall(markdown_text)

    for table_md in tables:
        # 清理表格字符串，移除多余的空格和换行符
        # 先按照&#39;\n&#39;符切割,去除每行前后的空白符,最后用&#39;\n&#39;连接
        cleaned_table = &#39;\n&#39;.join([line.strip() for line in table_md.splitlines()])

        # 去除开头&#39;\n&#39;
        cleaned_table = cleaned_table.lstrip(&#39;\n&#39;)

        # 使用正则表达式来分割行和单元格，保留空单元格
        rows = [
            [cell.strip() if cell.strip() else &#39; &#39; for cell in re.split(r&#39;\s*\|\s*&#39;, row.strip(&#39;|&#39;))]
            for row in cleaned_table.split(&#39;\n&#39;)
        ]

        # 过滤掉空行
        rows = [row for row in rows if row]

        # 检查是否是有效的表格（至少有两行：标题行和分隔符行）
        if len(rows) &lt; 2:
            continue

        # 跳过分隔符行（第二行通常是分隔符）
        header = rows[0]
        data_rows = rows[2:]  # 跳过分隔符行

        try:
            # 创建DataFrame
            df = pd.DataFrame(data_rows, columns=header)

            # 计算DataFrame内容的SHA256哈希值作为文件名
            csv_content = df.to_csv(index=False, encoding=&#39;utf-8&#39;)
            hash_object = hashlib.sha256(csv_content.encode(&#39;utf-8&#39;))
            csv_hash = hash_object.hexdigest()

            # 构建CSV文件名和路径
            csv_filename = f&#34;{csv_hash}.csv&#34;
            csv_filepath = os.path.join(output_dir, csv_filename)

            # 保存为CSV文件
            df.to_csv(csv_filepath, index=False, encoding=&#39;utf-8&#39;)

            print(csv_filename)
        except Exception as e:
            print(f&#34;Failed to process a table: {e}&#34;)
```

### 调用豆包 api

**发送文本**

``` python
from openai import OpenAI

async def extractInformation(user_content: str):
    client = OpenAI(
        base_url=&#34;xxxxxx&#34;,
        api_key=&#34;xxxxxx&#34;
    )

    # 发送请求
    completion = client.chat.completions.create(
        model=&#34;xxxxxx&#34;,
        messages = [
            {&#34;role&#34;: &#34;system&#34;, &#34;content&#34;: &#34;按照用户的要求输出指定的格式&#34;},
            {&#34;role&#34;: &#34;user&#34;, &#34;content&#34;: f&#34;内容:{user_content},帮我提炼信息,输出为xxx格式&#34;},
        ],
    )
    # 回复
    print(completion.choices[0].message.content)
```

&lt;br&gt;

**发送图片**

``` python
import imghdr
from openai import OpenAI

&#34;&#34;&#34;
image:二进制数据
&#34;&#34;&#34;
async def extractInformation(image):
        # 直接将字节数据转换为base64，不需要保存到磁盘再读取
        extension = imghdr.what(None, h=image)
        base64_encoded_data = base64.b64encode(image).decode(&#39;utf-8&#39;)
        client = OpenAI(
            base_url=&#34;xxxxxx&#34;,
            api_key=&#34;xxxxxx&#34;
        )
        model = &#34;xxxxxx&#34;
        completion = client.chat.completions.create(
            model=model,
            messages=[
                {&#34;role&#34;: &#34;system&#34;, &#34;content&#34;: &#34;提取图面内容,总结描述使用中文&#34;},
                {&#34;role&#34;: &#34;user&#34;,
                 &#34;content&#34;: [
                        {
                          &#34;type&#34;: &#34;text&#34;,
                          &#34;text&#34;: &#34;提取图面内容,总结描述使用中文&#34;,
                        },
                        {
                          &#34;type&#34;: &#34;image_url&#34;,
                          &#34;image_url&#34;: {
                          # 需要注意：传入Base64编码前需要增加前缀 data:image/{图片格式};base64,{Base64编码}：
                            &#34;url&#34;:  f&#34;data:image/{extension};base64,{base64_encoded_data}&#34;
                          },
                        },
                    ],
                 },
            ],
        )
        # print(completion.choices[0].message.content)
        return completion.choices[0].message.content
```


### 正则表达式

- `\s`：这是一个特殊序列，匹配任何空白字符（包括空格、制表符、换页符等）。在不同的编程语言和环境中，这可能还包括其他类型的空白字符，如零宽度空格。
- `*`：星号表示前面的元素可以出现 `0次` 或 `多次`。因此，`\s*` 意味着可以有 `0个` 或 `多个` 连续的空白字符。换句话说，它可以匹配没有任何空白字符的情况，也可以匹配有一个或多个空白字符的地方。
- `|`：竖线符号是正则表达式中的一个字面量，它本身没有特殊含义，只是用来匹配竖线字符 `|`。如果想要匹配实际的竖线字符，通常需要对其进行转义，即使用反斜杠 `\|`。但在某些上下文中，比如定义字符集 `[|]` 或者在某些编程语言中，直接使用 `|` 也可能是允许的。
- `.`：点号 `.` 在正则表达式中是一个特殊字符，代表 `&#34;任意单个字符&#34;`，除了换行符之外（在某些模式下也可能包括换行符）。  

&#34;content=&#39;(.*?)&#39;&#34;  
- `?`：问号 `?` 在这里使前面的量词 `*` 变为非贪婪模式。默认情况下，量词是贪婪的，它们会尽可能多地匹配字符。加上 `?` 后，量词变得非贪婪，即尽可能少地匹配字符，直到满足匹配条件为止。这对于确保只匹配最短的可能字符串很有用，特别是在有多个可能的结束标记的情况下。


### any

根据需求将 `true, false, false` 替换为布尔表达式，`any()` 中可以添加多个。  

``` python
# 只要有一个为 true,结果为true,否则为false
bol = any(true, false, false)
```


### shell脚本找不到
问题：python 调用脚本报错，脚本找不到，但是路径是正确的

原因：脚本在 windows 上打开过，打开后 windows 自动更换了脚本中的空格，格式出现问题，linux 报错，提示：脚本找不到


---
{.awesome-hr}

---

> 作者: [piliqiu](https://piliqiu.com/)  
> URL: https://piliqiu.com/posts/38eeaf0/  

